<?php
	
	list ($channel) = $irc_call_args;
	
	$game = $this->custom_vars->yandere_games[$channel];
	
	$game->hurry_votes = array ();
	$game->hurried = false;
	
	$game->had_day = true;
	
	if (!$game->had_night)
	{
		// This is the first turn.
		
		output($channel, $game->s.'This game starts at DAY. Discuss.'.$game->e);
	}
	else
	{
		// Not the first turn. A night just passed.
		
		$game->turn++;
		
		$guarded = array ();
		$killed = array ();
		$yandere_votes = array ();
		$night_msgs = array ();
		
		foreach ($game->votes as $user_id => $vote_id)
		{
			if ($vote_id === false)
			{
				continue;
			}
			
			$user = $game->players[$user_id];
			$target = $game->players[$vote_id];
			
			switch ($user->get_can_act(1, false, $target, true))
			{
			case 'check':
				$night_msgs[$user_id][] = $target->nick.' '.($target->is_enemy ? 'seems' : 'does not seem').' to be evil.';
				break;
			
			case 'hide':
				$guarded[] = $user_id;
				break;
			
			case 'guard':
				$guarded[] = $vote_id;
				
				if ($target->deadly_to_guard)
				{
					$killed[] = $user_id;
				}
				break;
			
			case 'spy':
				$night_msgs[$user_id][] = $target->nick.' looks like a '.$target->appearance.'.';
				break;
			
			case 'stalk':
				if (!isset ($game->votes[$vote_id]) || $game->votes[$vote_id] === false || $game->votes[$vote_id] == $vote_id)
				{
					$night_msgs[$user_id][] = $target->nick.' stayed at home last night.';
				}
				else
				{
					$night_msgs[$user_id][] = $target->nick.' went to '.$game->players[$game->votes[$vote_id]]->nick.'\'s house last night.';
				}
				break;
			
			case 'kill':
				$killed[] = $vote_id;
				break;
			
			case 'vote':
				if (!isset ($yandere_votes[$vote_id]))
				{
					$yandere_votes[$vote_id] = 1;
				}
				else
				{
					$yandere_votes[$vote_id]++;
				}
				break;
			}
			
			if ($user->get_can_act(1, false, null, true) != 'vote')
			{
				$user->did_action = true;
			}
		}
		
		if (!empty ($yandere_votes))
		{
			$yandere_pick = null;
			$yandere_max = 0;
			
			foreach ($yandere_votes as $user_id => $num)
			{
				if ($num > $yandere_max)
				{
					$yandere_pick = $user_id;
					$yandere_max = $num;
				}
			}
			
			if (!is_null($yandere_pick))
			{
				$killed[] = $yandere_pick;
			}
		}
		
		$killed = array_unique($killed);
		$killed = array_diff($killed, $guarded);
		
		foreach ($night_msgs as $user_id => $msgs)
		{
			if (in_array($user_id, $killed))
			{
				// The player was killed. Don't bother telling them any of the action results.
				continue;
			}
			
			foreach ($msgs as $msg)
			{
				notice($game->players[$user_id]->nick, $game->s.$msg.$game->e);
			}
		}
		
		if (empty ($killed))
		{
			output($channel, $game->s.'The dawn comes, and it seems everyone survived the night.'.$game->e);
		}
		else
		{
			output($channel, $game->s.'Morning comes with the stench of death.'.$game->e);
			
			$yanderes_killed = array ();
			
			foreach ($killed as $key => $user_id)
			{
				$target = $game->players[$user_id];
				
				output($channel, $game->s.$game->theme->describe_death($target, $game->blind_roles).'.'.$game->e);
				
				if ($target->is_mafioso)
				{
					$yanderes_killed[] = $target->nick;
				}
				
				$killed[$key] = $target->nick;
				
				unset ($game->players[$user_id]);
			}
		}
		
		if (call('yandere/check-game-over', $channel))
		{
			return;
		}
	}
	
	foreach ($game->players as $player)
	{
		if (!$player->single_use)
		{
			$player->did_action = false;
		}
	}
	
	$game->votes = array ();
	
	// Schedule a reminder to vote or abstain.
	
	if ($game->turn <= 2)
	{
		$this->schedule_event(time() + 300 * (floor($game->turn / 2) + 1), array ('yandere/day-reminder', $channel, $game->start_time, $game->turn));
	}
	
	// Schedule the sunset.
	
	$this->schedule_event(time() + 1800, array ('yandere/day-sunset', $channel, $game->start_time, $game->turn));
	
	// Status.
	
	$players = array ();
	
	foreach ($game->players as $player)
	{
		$players[] = $player->nick;
	}
	
	// Give voice to all players.
	
	call('yandere/give-voice', $channel);
	
	output($channel, $game->s.'Current players: '.implode_comma_series($players).'.'.$game->e);
	
?>
