<?php
	
	list ($topic) = $irc_call_args;
	
	$topic = strtolower($topic);
	
	if ($to === $from)
		$channel = call('yandere/get-player-channel', call('yandere/get-user-id', $from));
	else
	$channel = irc_lower($to);
	
	$game = $this->custom_vars->yandere_games[$channel];
	if (isset($game))
		$theme = $game->theme;
	else
	{
		include_once(dirname(__FILE__)."/../themes/default.php");
		$YTC = 'Yandere_theme_' . $this->custom_vars->yandere_default_theme;
		$theme = new $YTC;
	}
	
	switch ($topic)
	{
	case 'mode':
	case 'modes':
	case 'parameters':
	case 'params':
	case 'start':
		notice($from, 'To start a game in special modes, type "'.call('yandere/get-format-command', $to, array(array('', 'join', 'start'), '<parameters>')).'" where <parameters> is one or more space-seperated parameters of format <param>[=<value>]:');
		notice($from, 'basic :Create a game containing only yanderes, spies, guardians, and civilians.');
		notice($from, 'forbid-early-kills :Don\'t allow good guy night-kill roles to kill on the first night.');
		notice($from, 'invert :Game messages are displayed using inverted text.');
		notice($from, '+m :Restricted-voice mode. Only players can talk in '.call('yandere/get-channel-strings', $to, array('the channel')).', and only at day.');
		notice($from, 'theme :Select a theme to play with.');
		notice($from, 'visible-roles :Roles are publicly announced at the beginning of the game and upon death.');
		notice($from, '<number> :The numbers of seconds allotted for joining the game. The default is 60.');
		return;
	
	case 'roles':
		notice($from, 'Type "'.call('yandere/get-format-command', $to, array('help', '<role>')).'" where <role> is one of: '.implode(', ', $theme->all_roles()));
		return;
	
	default:
		if (false !== $key = $theme->role_fromplural($topic))
		{
			$topic = $key;
		}
		
		$desc = $theme->role_description($topic, $to);
		
		if ($desc === false)
		{
			notice($from, 'I don\'t know what that is.');
			return;
		}
		
		if ($desc)
		{
			notice($from, $desc);
		}
		else
		{
			notice($from, 'I don\'t have a description for that yet.');
		}
		
		return;
	}
	
?>
