<?php
	
	list ($user_id, $params) = $irc_call_args;
	
	if ($from == $to)
	{
		$CS = call('yandere/get-channel-strings', $to, array('the channel', 'PM(c)'));
		output($from, 'Please type that in '.$CS['the channel'].', not in '.$CS['PM(c)'].'.');
		return;
	}
	
	foreach ($this->custom_vars->yandere_games as $channel => $game)
	{
		if (isset ($game->players[$user_id]))
		{
			// The user is already in a game.
			
			if ($channel == irc_lower($to))
			{
				notice($from, 'You\'re already in the ' . ($game->active ? '' : 'pending ') . 'game.');
			}
			else
			{
				output($to, $from.': You\'re already playing a game on '.call('yandere/get-channel-strings', $to, 'this network').'. You can only be in one at a time.');
			}
			
			return;
		}
	}
	
	$channel = irc_lower($to);
	
	// TODO: move this some common place
	if (!function_exists('ctype_digit'))
	{
		function ctype_digit ($n) {
			return !!preg_match('/\d+/', $n);
		}
	}
	
	if (!isset ($this->custom_vars->yandere_games[$channel]))
	{
		// Start a new game.
		
		$game = $this->custom_vars->yandere_games[$channel] = new Yandere_game($this, $channel);
		
		$game->starter = $user_id;
		$game->start_time = time();
		
		//$game->restrict_voice = $this->channel($to)->is_op($this->nick);
		$game->restrict_voice = false;
		$game->blind_roles = 1;
		$game->complexity = 'normal';
		$FontCodes = call('yandere/get-channel-strings', $to, array(
			'(BOLD)',
			'(REVERSE)',
		));
		$game->s = $FontCodes['(BOLD)'];
		$game->e = $FontCodes['(BOLD)'];
		$game->start_mode = null;
		$delay = 60;
		$game->max_extensions = 1;
		$game->forbid_early_kill = false;
		$game->theme_choice = null;
		$game->evil_sympathy = 6;
		
		foreach ($params as $param)
		{
			$pv = explode('=', $param, 2);
			$param = strtolower($pv[0]);
			if (isset($pv[1]))
				$value = $pv[1];
			else
				$value = true;
			switch (strtolower($value))
			{
			case 'false':
			case 'n':
			case 'no':
			case 'off':
				$bvalue = false;
				break;
			default:
				$bvalue = $value;
			}
			
			switch ($param)
			{
			case 'allow-early-kill':
			case 'allow-early-kills':
				$game->forbid_early_kill = !$bvalue;
				break;
			
			case 'basic':
			case 'simple':
				$game->complexity = 'basic';
				break;
			
			case 'blind':
			case 'blind-roles':
				$game->blind_roles = $bvalue;
				break;
			
			case 'blind-random':
			case 'blind-rand':
			case 'random-blind':
			case 'rand-blind':
				$game->blind_roles = mt_rand(0, 1) == 1;
				break;
			
			case 'bold':
			case 'bold-text':
				$game->s = $FontCodes['(BOLD)'];
				$game->e = $FontCodes['(BOLD)'];
				break;
			
			case 'day':
				$game->start_mode = 'day';
				break;
			
			case 'delay':
				if (ctype_digit($value))
					$delay = $value;
				break;
			
			case 'evil':
				if (!$bvalue)
					$game->evil_sympathy = false;
				else
				if (ctype_digit($value))
					$game->evil_sympathy = $value;
				else
					$game->evil_sympathy = 6;
				break;
			
			case 'forbid-early-kill':
			case 'forbid-early-kills':
				$game->forbid_early_kill = $bvalue;
				break;
			
			case 'invert':
			case 'invert-text':
			case 'inverted':
			case 'inverted-text':
			case 'reverse':
			case 'reverse-text':
			case 'reversed':
			case 'reversed-text':
				$game->s = $FontCodes['(REVERSE)'];
				$game->e = $FontCodes['(REVERSE)'];
				break;
			
			case '+m':
			case 'm':
			case 'moderated':
			case 'no-voice':
			case 'restrict-voice':
			case 'restricted-voice':
				$game->restrict_voice = $bvalue;
				break;
			
			case '-m':
			case 'unmoderated':
			case 'unrestrict-voice':
			case 'unrestricted-voice':
				$game->restrict_voice = !$bvalue;
				break;
			
			case 'night':
				$game->start_mode = 'night';
				break;
			
			case 'normal':
			case 'standard':
				$game->complexity = 'normal';
				break;
			
			case 'normal-text':
			case 'plain-text':
				$game->s = '';
				$game->e = '';
				break;
			
			case 'theme':
			case 'skin':
			case 'style':
				$value = preg_replace('/\W+/', '_', $value);
				$value = strtolower($value);
				$game->theme_choice = $value;
				break;
			
			case 'show-visible-roles':
			case 'visible-roles':
				$game->blind_roles = !$bvalue;
				break;
			
			default:
				if (ctype_digit($param))
				{
					$delay = $param;
				}
				else
				{
					unset ($this->custom_vars->yandere_games[$channel]);
					
					output($to, 'I don\'t recognize "'.$param.'" as a mode.');
					
					call('yandere/help', 'modes');
					
					return;
				}
			}
		}
		
		call('yandere/set-up-roles');
		
		if ($game->restrict_voice && !$this->channel($to)->is_op($this->nick))
		{
			// The bot doesn't have ops.
			
			output($to, 'We can\'t play a restricted-voice game in here unless someone gives me ops.');
			
			unset ($this->custom_vars->yandere_games[$channel]);
			return;
		}
		
		output($to, $game->s.ucfirst($game->theme->game_name_full).' is starting in '.$delay.' '.str_plural('second', $delay).'! Please type "'.call('yandere/get-format-command', $to, array(array('', 'join', 'start'))).'" to join.'.$game->e);
		
		$this->schedule_event(time() + $delay, array ('yandere/start-game', $channel, $game->start_time, 0));
	}
	elseif ($this->custom_vars->yandere_games[$channel]->active)
	{
		notice($from, 'The game is already in progress.');
		return;
	}
	
	notice($from, 'You\'ve joined the pending game.');
	
	$game = $this->custom_vars->yandere_games[$channel];
	
	$user = $game->players[$user_id] = new Yandere_user($game, $user_id, $from);
	
?>
