<?php
	
	list ($channel, $vote_id) = $irc_call_args;
	
	$game = $this->custom_vars->yandere_games[$channel];
	
	$game->hurry_votes = array ();
	$game->hurried = false;
	
	$game->had_night = true;
	
	$game->turn++;
	
	if ($game->had_day)
	{
		if ($vote_id === false)
		{
			output($channel, $game->s.'You abstain from lynching anyone. '.$game->e);
		}
		elseif (is_null($vote_id))
		{
			output($channel, $game->s.'You fail to make a decision. No one is lynched. '.$game->e);
		}
		else
		{
			$target = $game->players[$vote_id];
			
			if ($game->blind_roles)
			{
				$role = ($target->is_mafioso ? '' : 'NOT ') . 'a ' . $game->theme->get_standard_role('mafioso');
			}
			else
			{
				$role = 'a '.$target->role;
			}
			
			output($channel, $game->s.'You lynch '.$target->nick.', and it turns out '.$target->nick.' was '.$role.'!'.$game->e);
			
			unset ($game->players[$vote_id]);
		}
		
		if (call('yandere/check-game-over', $channel))
		{
			return;
		}
	}
	
	foreach ($game->players as $player)
	{
		if (!$player->single_use)
		{
			$player->did_action = false;
		}
	}
	if ($game->had_day && $game->evil_sympathy && rand(1, $game->evil_sympathy) == 1)
	{
			// Player changes sides :O
		$player = $game->players[array_rand($game->players)];
		if (!$player->is_enemy)
		{
			$player->is_enemy = 1;
			notice($player->nick, $game->s.'You\'re EVIL! You begin to sympathize with the '.$game->theme->role_plural($game->theme->get_standard_role('mafioso')).'. From this point forward, you will win only if they win.'.$game->e);
		}
	}
	
	$game->votes = array ();
	
	// Schedule the sunset.
	
	$this->schedule_event(time() + 180, array ('yandere/night-sunrise', $channel, $game->start_time, $game->turn));
	
	// Remove voice from all players.
	
	call('yandere/remove-voice', $channel);
	
	// Status.
	
	$players = array ();
	
	foreach ($game->players as $player)
	{
		$players[] = $player->nick;
	}
	
	output($channel, $game->s.($game->had_day ? 'Night time falls.' : 'This game starts at NIGHT.').' If you have a night role, type "'.call('yandere/get-format-command', null, '<command>').'" or "'.call('yandere/get-format-command', null, 'abstain').'".'.$game->e);
	
	output($channel, $game->s.'Current players: '.implode_comma_series($players).'.'.$game->e);
	
?>
