<?php
	
	require_once (dirname(__FILE__).'/classes/yandere-game.php');
	require_once (dirname(__FILE__).'/classes/yandere-user.php');
	require_once (dirname(__FILE__).'/classes/yandere-theme.php');
	
	if (!function_exists('add_handler'))
	{
		// Newer Pharo handler system renames:
		//     handle => hook
		//     add_handler => handle
		function add_handler ($handle, $func)
		{
			return handle($handle, $func);
		}
	}
	
	function irc_yandere_handler ($args)
	{
		list ($server, $param_str, $params) = $args;
		
		$server->call('yandere/main', $params);
	}
	
	add_handler('irc-command-yandere', 'irc_yandere_handler');
	add_handler('irc-command-yandre', 'irc_yandere_handler');
	add_handler('irc-command-yandree', 'irc_yandere_handler');
	
	// Command shortcuts.
	
	function irc_yandere_guard_handler ($args)
	{
		list ($server, $param_str, $params) = $args;
		
		$server->call('yandere/main', array_merge(array ('guard'), $params));
	}
	
	add_handler('irc-command-guard', 'irc_yandere_guard_handler');
	
	function irc_yandere_hide_handler ($args)
	{
		list ($server, $param_str, $params) = $args;
		
		$server->call('yandere/main', array ('hide'));
	}
	
	add_handler('irc-command-hide', 'irc_yandere_hide_handler');
	
	function irc_yandere_kill_handler ($args)
	{
		list ($server, $param_str, $params) = $args;
		
		$server->call('yandere/main', array_merge(array ('kill'), $params));
	}
	
	add_handler('irc-command-kill', 'irc_yandere_kill_handler');
	
	function irc_yandere_reveal_handler ($args)
	{
		list ($server, $param_str, $params) = $args;
		
		$server->call('yandere/main', array ('reveal'));
	}
	
	add_handler('irc-command-reveal', 'irc_yandere_reveal_handler');
	
	function irc_yandere_spy_handler ($args)
	{
		list ($server, $param_str, $params) = $args;
		
		$server->call('yandere/main', array_merge(array ('spy'), $params));
	}
	
	add_handler('irc-command-spy', 'irc_yandere_spy_handler');
	
	function irc_yandere_stalk_handler ($args)
	{
		list ($server, $param_str, $params) = $args;
		
		$server->call('yandere/main', array_merge(array ('stalk'), $params));
	}
	
	add_handler('irc-command-stalk', 'irc_yandere_stalk_handler');
	
	function irc_yandere_vote_handler ($args)
	{
		list ($server, $param_str, $params) = $args;
		
		$server->call('yandere/main', array_merge(array ('vote'), $params));
	}
	
	add_handler('irc-command-vote', 'irc_yandere_vote_handler');
	
	function irc_yandere_abstain_handler ($args)
	{
		list ($server, $param_str, $params) = $args;
		
		$server->call('yandere/main', array_merge(array ('abstain'), $params));
	}
	
	add_handler('irc-command-abstain', 'irc_yandere_abstain_handler');
	
	function irc_yandere_unvote_handler ($args)
	{
		list ($server, $param_str, $params) = $args;
		
		$server->call('yandere/main', array_merge(array ('unvote'), $params));
	}
	
	add_handler('irc-command-unvote', 'irc_yandere_unvote_handler');
	
?>
