<?php
	
	class Yandere_theme_food extends Yandere_theme
	{
		public function __construct ()
		{
			$this->name = 'Food';
			
			$this->game_name = 'food';
			$this->game_name_full = 'a food game';
			$this->game_name_specific = 'the food game';
			$this->game_name_plural = 'food games';
			
			$this->generic_victims[] = array(
				'name' => 'Tea',
				'gender' => 'female',
			);
			$this->generic_victims[] = array(
				'name' => 'Green Tea',
				'gender' => 'female',
			);
			$this->generic_victims[] = array(
				'name' => 'Coffee',
				'gender' => 'male',
			);
			
			if (property_exists($this, 'role_upgrades'))
			{
			
			$this->role_upgrades += array
			(
				'cracker' => array('potato', 'beef', 'pear', 'banana', 'radish', 'esparagus', 'vegetable oil'),
				'aspartame' => 'sucralose',
				'pear' => 'apple',
				'banana' => array('turkey', 'salt'),
				'vegetable oil' => 'vinegar',
				'monosodium glutamate' => array('sucralose', 'poisoned apple'),
				'turkey' => 'steak',
				'salt' => 'garlic',
				'esparagus' => 'spinach',
				'potato' => 'french fry',
				'cyclamate' => array('water', 'aspartame'),
				'seaweed extract' => array('cracker', 'esparagus'),
				'beef' => array('chicken', 'turkey'),
				'radish' => 'carrot',
				'chemical' => array('aspartame', 'monosodium glutamate', 'ethanol', 'poisoned apple', 'artificial turkey', 'saccharin'),
				'ethanol' => 'aspartame',
			);
			
			$this->role_reveal_as += array
			(
				'sucralose' => 'vinegar',
				'artificial turkey' => 'steak',
				'saccharin' => 'garlic',
				'poisoned apple' => 'apple',
			);
			
			$this->role_odds['salt'] = 10;
			$this->role_odds['garlic'] = 3;
			
			}
			
			$this->role_plurals += array
			(
				'water' => 'water',
				'cracker' => 'crackers',
				'sucralose' => 'sucralose',
				'aspartame' => 'aspartame',
				'pear' => 'pears',
				'vinegar' => 'vinegar',
				'french fry' => 'french fries',
				'banana' => 'bananas',
				'vegetable oil' => 'vegetable oil',
				'monosodium glutamate' => 'monosodium glutamate',
				'turkey' => 'turkeys',
				'steak' => 'steaks',
				'salt' => 'salt',
				'garlic' => 'garlic',
				'chicken' => 'chicken',
				'apple' => 'apples',
				'carrot' => 'carrots',
				'potato' => 'potatos',
				'saccharin' => 'saccharin',
				'seaweed extract' => 'seaweed extract',
				'beef' => 'beefs',
				'radish' => 'radishes',
				'chemical' => 'chemicals',
				'ethanol' => 'ethanols',
				'artificial turkey' => 'artificial turkeys',
				'cyclamate' => 'cyclamate',
				'poisoned apple' => 'poisoned apples',
			);
			
			$this->standard_roles += array
			(
				'innocent' => 'cracker',
				'mafioso' => 'chemical',
				'spinach' => 'apple',
				// FIXME: allow config selection of unique-special role, default to apple or random
			);
			
			$this->role_actions[0] += array // Day
			(
				'pear' => 'apple',
				'sucralose' => 'apple',
				'banana' => 'reveal',
				'monosodium glutamate' => 'apple',
				'turkey' => 'kill',
				'steak' => 'kill',
				'salt' => 'upgrade',
				'garlic' => 'upgrade',
				'artificial turkey' => 'kill',
				'saccharin' => 'upgrade',
				'poisoned apple' => 'apple',
			);
			$this->role_actions[1] += array // Night
			(
				'sucralose' => 'vote',
				'aspartame' => 'vote',
				'spinach' => 'check',
				'vinegar' => 'guard',
				'french fry' => 'hide',
				'vegetable oil' => 'guard',
				'monosodium glutamate' => 'vote',
				'turkey' => 'kill',
				'chicken' => 'kill',
				'esparagus' => 'check',
				'apple' => 'apple',
				'carrot' => 'stalk',
				'potato' => 'hide',
				'beef' => 'kill',
				'radish' => 'stalk',
				'chemical' => 'vote',
				'ethanol' => 'vote',
				'artificial turkey' => 'vote',
				'saccharin' => 'vote',
				'poisoned apple' => 'vote',
			);
			
			$this->action_messages[0] += array
			(
				'banana' => 'A limousine pulls up and the famous banana \\1 steps out! \\1 hands everyone autographed copies of the latest album, "I Want You Lovely".',
				'turkey' => '\\1 pulls out a skewer and drives it through \\2\'s chest! \\2\\3 falls over and dies.',
				'steak' => '\\1 pulls out a skewer and drives it through \\2\'s chest! \\2\\3 falls over and dies.',
				'artificial turkey' => '\\1 pulls out a skewer and drives it through \\2\'s chest! \\2\\3 falls over and dies.',
			);
			
			$this->enemy_roles = array_merge($this->enemy_roles, array
			(
				'aspartame',
				'sucralose',
				'monosodium glutamate',
				'saccharin',
				'chemical',
				'ethanol',
				'artificial turkey',
				'cyclamate',
				'poisoned apple',
			)
			);
			
			$this->always_win_roles = array_merge($this->always_win_roles, array
			(
				'water',
			)
			);
			
			$this->yandere_role_odds += array
			(
				'chemical' => 50,
				
				'monosodium glutamate' => 15,
				
				'sucralose' => 5,
				'aspartame' => 5,
				
				'artificial turkey' => 3,
				'saccharin' => 3,
				'poisoned apple' => 2,
			);
			
			$this->role_odds += array
			(
				'seaweed extract' => 15,
				
				'cyclamate' => 10,
				'cracker' => 180,
				
				'beef' => 25,
				'pear' => 25,
				'potato' => 25,
				'banana' => 25,
				'vegetable oil' => 25,
				'esparagus' => 25,
				'radish' => 25,
				
				'turkey' => 10,
				
				'vinegar' => 8,
				
				'steak' => 3,
				'water' => 3,
				'spinach' => 3,
				'french fry' => 3,
				'chicken' => 3,
				'apple' => 3,
				'carrot' => 3,
			);
			
			$this->single_use_roles = array_merge($this->single_use_roles, array
			(
				'sucralose',
				'pear',
				'banana',
				'monosodium glutamate',
				'vegetable oil',
				'turkey',
				'salt',
				'esparagus',
				'potato',
				'beef',
				'radish',
				'artificial turkey',
				'saccharin',
			)
			);
			
			$this->role_appearances += array
			(
				'sucralose' => 'pear',
				'aspartame' => 'cracker',
				'esparagus' => 'chemical',
				'spinach' => 'chemical',
				'cyclamate' => 'cracker',
				'seaweed extract' => 'chemical',
			);
			if (property_exists($this, 'role_appearances_multi') && $this->role_appearances_multi)
			{
			$this->role_appearances = array
			(
				'sucralose' => array('cracker', 'potato', 'french fry', 'vegetable oil', 'vinegar', 'beef', 'pear', 'apple', 'chicken'),
				'aspartame' => array('cracker', 'potato', 'french fry', 'vegetable oil', 'vinegar', 'beef', 'radish', 'carrot', 'chicken'),
				'spinach' => array('chemical', 'poisoned apple', 'ethanol', 'strawberry chemical'),
				'esparagus' => array('chemical', 'monosodium glutamate', 'ethanol', 'vanilla chemical', 'saccharin'),
				'cyclamate' => array('cracker', 'potato', 'french fry', 'vegetable oil', 'vinegar', 'beef', 'radish', 'esparagus', 'spinach'),
				'seaweed extract' => array('chemical', 'monosodium glutamate', 'artificial turkey', 'saccharin', 'ethanol', 'chocolate chemical'),
			) + $this->role_appearances;
			}
			
			if (property_exists($this, 'guard_friendly'))
			{
			
			$this->guard_friendly = @array_merge($this->guard_friendly, array
			(
				'ethanol',
			)
			);
			
			$this->yandere_role_odds['ethanol'] = 15;
			
			}
			
			$this->role_descriptions += array
			(
				'water' => 'Water has no stakes in the game. You win no matter who wins. Feel free to sabotage either side, and have fun with it. You don\'t have any special abilities.',
				'cracker' => 'Crackers are normal foodstuff with no special abilities.',
				'sucralose' => 'Sucralose is a chemical that can inspect another player\'s role one time during a day of your choosing, and also look normal to spies. Type "\\3spy <user>" during the day or "\\3vote <user>" during the night.',
				'aspartame' => 'Aspartame is a chemical that look normal to spies. Each night, you vote to kill someone by typing "\\3vote <user>". The majority vote among the chemicals wins. Earlier votes break ties.',
				'spinach' => 'Spinach look like chemicals, but can inspect another player\'s alignment each night. Type "\\3check <user>".',
				'pear' => 'Pears can inspect another player\'s role one time during a day of your choosing. Type "\\3spy <user>". Be careful of disguised roles like cyclamate and seaweed extracts which will be misreported.',
				'vinegar' => 'Vinegar has the ability to protect a player from any danger during the night. Type "\\3guard <user>". But be careful: if you protect a chemical, the chemical will also attack you!',
				'french fry' => 'French fries can choose to hide each night, keeping safe from any killers. Type "\\3hide" during the night.',
				'banana' => 'Bananas are famous! At any time during a day of your choice, you can type "\\3reveal" to prove to everyone that you\'re an banana.',
				'vegetable oil' => 'Vegetable oil has the ability to protect a player from any danger once during the night. Type "\\3guard <user>". But be careful: if you protect a chemical, the chemical will also attack you!',
				'monosodium glutamate' => 'Monosodium glutamate is a chemical that can inspect another player\'s role one time during a day of your choosing. Type "\\3spy <user>" during the day or "\\3vote <user>" during the night.',
				'turkey' => 'Turkey have the ability to single-handedly kill a player of their choosing once during a night or day of your choosing. Type "\\3kill <user>" if you believe that person is a chemical.',
				'steak' => 'Steak have the ability to single-handedly kill a player of their choosing each day. Type "\\3kill <user>" if you believe that person is a chemical.',
				'salt' => 'Salt can upgrade any other food once during the day by typing "\\3upgrade <user>".',
				'garlic' => 'Garlic can upgrade any other food once each day by typing "\\3upgrade <user>".',
				'chicken' => 'Chicken have the ability to single-handedly kill a player of their choosing each night. Type "\\3kill <user>" if you believe that person is a chemical.',
				'esparagus' => 'Esparagus look like chemicals, but can inspect another player\'s alignment one time during a night of your choosing. Type "\\3check <user>".',
				'apple' => 'Apples can inspect another player\'s role each night. Type "\\3spy <user>". Be careful of disguised roles like cyclamate and seaweed extracts which will be misreported.',
				'carrot' => 'Carrots can learn where another player goes during the night. Each night, type "\\3stalk <user>". Although you can see a player\'s target, you can\'t see what action the player is performing on that target.',
				'potato' => 'Potatos can choose to hide during a night of your choosing, keeping safe from any killers that night. Type "\\3hide" during the night.',
				'cyclamate' => 'Cyclamate are normal crackers with no special abilities, except you only win if the chemicals win. You want to sabotage the game in favor of the chemicals. Spies will mistake you for a cracker.',
				'seaweed extract' => 'Seaweed extract are normal food with no special abilities, except spies will mistake them for chemicals.',
				'beef' => 'Beef have the ability to single-handedly kill a player of their choosing once during a night of your choosing. Type "\\3kill <user>" if you believe that person is a chemical.',
				'radish' => 'A radish can learn where another player goes one time during the night of your choosing. When you wish, type "\\3stalk <user>". Although you can see a player\'s target, you can\'t see what action the player is performing on that target.',
				'chemical' => 'Chemicals are the villains of the game. Each night, you vote to kill someone by typing "\\3vote <user>". The majority vote among the chemicals wins. Earlier votes break ties.',
				'ethanol' => 'Ethanol is a chemical that can be safely guarded. Each night, you vote to kill someone by typing "\\3vote <user>". The majority vote among the chemicals wins. Earlier votes break ties.',
				'artificial turkey' => 'Artificial turkey have the ability to single-handedly kill a player of their choosing once during a day of your choosing. Type "\\3kill <user>" if you want to kill that person, and "\\3vote <user>" each night.',
				'saccharin' => 'Saccharin have the ability to upgrade any other player once during the day by typing "\\3upgrade <user>". Use "\\3vote <user>" each night.',
				'poisoned apple' => 'Poisoned apples are chemicals that can inspect another player\'s role each day. Type "\\3spy <user>" during the day or "\\3vote <user>" during the night.',
			);
			if (property_exists($this, 'role_appearances_multi') && $this->role_appearances_multi)
			{
			$this->role_descriptions = array
			(
				'sucralose' => 'Sucralose is a chemical that can inspect another player\'s role one time during a day of your choosing, and also look like legitimate roles to spies. Type "\\3spy <user>" during the day or "\\3vote <user>" during the night.%appear%',
				'aspartame' => 'Aspartame is a chemicals that look like legitimate roles to spies. Each night, you vote to kill someone by typing "\\3vote <user>". The majority vote among the chemicals wins. Earlier votes break ties.%appear%',
				'cyclamate' => 'Cyclamate are normal crackers with no special abilities, except you only win if the chemicals win. You want to sabotage the game in favor of the chemicals. Spies will mistake you for a legitimate role.%appear%',
			) + $this->role_descriptions;
			}
			
			$this->weapons = array_merge($this->weapons, array
			(
				'a crowbar',
				'an axe',
				'a sword',
				'dynamite',
				'a wrench',
				'a fork',
				'a giant plushie',
				'dihydrogen monoxide',
				'a machine gun',
				'a cheese grater',
				'a rolling pin',
				'a frying pan',
				'a staple gun',
				'a sledgehammer',
				'a major papercut',
				'a pineapple',
				'a box of gummy worms',
				'a giant snake',
				'excalibolg',
				'a pretzel',
				'a death note',
				'a mecha',
				'a bowling ball',
				'AIDS',
				'a tentacle monster',
				'a tennis racket',
				'an exploding pen',
				'a cannon',
				'laser beams',
				'a hot glue gun',
				'a frisby',
				'a mutant bee sting',
				'a shark',
				'a yo-yo',
				'ESP',
				'a yak',
				'a box of starving, crazed weasels',
				'a shuriken',
				'a banana',
				'a thermal detonator',
				'a falling house',
				'a Masamune',
				'a mouse trap',
				'a walrus with a top hat',
				'fire',
				'suicide',
				'cancer',
				'a hybrid vehicle',
				'lolipops',
				'poison cake',
				'a sugar overdose',
				'a Vulcan nerve pinch',
				'a rift in space-time',
				'the power of the void',
				'a rock',
				'a chicken gun',
				'the force',
				'a large hadron collider',
				'a silver bullet',
				'a carrier swarm',
			)
			);
			
			$this->murder_descriptions = array_merge($this->murder_descriptions, array
			(
				'has been brutally murdered by',
				'is dead, killed by',
				'was taken out by',
				'has been killed by',
				'has been murdered by',
				'is lying on the floor, murdered by',
				'has been savagely killed by',
				'was assassinated with',
				'was eliminated by',
				'was knocked off with',
				'has been slain by',
				'was wasted by',
				'was done in by',
			)
			);
		}
		
		public function get_introduction ($phase)
		{
			$GV = $this->generic_victim();
			
			$description1 .= $this->describe_death(null, false).'. ';
			
			switch (mt_rand(0, 2))
			{
			case 0:
				$description2 = 'This looks like the work of '.$this->role_singular($this->get_standard_role('mafioso')).'!';
				break;
			
			case 1:
				$description2 = 'There\'s only one explanation: there is '.$this->role_singular($this->get_standard_role('mafioso')).' among us!';
				break;
			
			case 2:
				$description2 = $GV['E'] . ' seems to have been the victim of '.$this->role_singular($this->get_standard_role('mafioso')).'!';
				break;
			}
			
			switch (mt_rand(0, 11))
			{
			case 0:
				return 'TAIHEN!! The village wakes up one morning to a horrible surprise: ' . $GV['name'] . ' '.$description1.$description2;
			case 1:
				return 'All the little children go to school one day and notice that ' . $GV['name'] . ' seems to be missing. After school, you go to ' . $GV['eir'] . ' house to check on ' . $GV['em'] . ', and find that ' . $GV['e'] . ' '.$description1.$description2;
			case 2:
				return 'At '.mt_rand(2, 4).':'.str_pad(mt_rand(0, 59), 2, '0', STR_PAD_LEFT).' in the morning, the neighborhood wakes up to a scream. It sounds like ' . $GV['name'] . '! You all run to ' . $GV['eir'] . ' room and find that ' . $GV['e'] . ' '.$description1.$description2;
			case 3:
				return 'Today is ' . $GV['name'] . '\'s birthday! And ' . $GV['e'] . '\'s having ichigo cake! All the townspeople eagerly come to ' . $GV['eir'] . ' house, but they\'re met with a surprise: ' . $GV['name'] . ' '.$description1.$description2;
			case 4:
				return $GV['name'] . ' is a quiet, moe fellow. But ' . $GV['e'] . '\'s especially quiet today, because ' . $GV['e'] . ' '.$description1.$description2;
			case 5:
				return 'It\'s Christmas morning! ' . $GV['name'] . ' rushes into the living room and sees a great big present with ' . $GV['eir'] . ' name on it. Full of excitement, ' . $GV['e'] . ' rips open the box and finds some sort of weird alarm clock attached to several red sticks. It proceeds to explode. '.$description2;
			case 6:
				return $GV['name'] . ' is riding merrily on the bus on ' . $GV['eir'] . ' way to school. Little does ' . $GV['e'] . ' know it\'s rigged with hundreds of explosives. The bus explodes in a mighty inferno, and ' . $GV['name'] . ' bits go flying everywhere. '.$description2;
			case 7:
				return 'All ' . $GV['eir'] . ' life, ' . $GV['name'] . ' had been plagued by an illness that confined ' . $GV['em'] . ' to ' . $GV['eir'] . ' room. But today, ' . $GV['e'] . ' decided to fulfill ' . $GV['eir'] . ' dream: to risk it and go to school like all the other kids. But ' . $GV['eir'] . ' lunch was poisoned and ' . $GV['e'] . ' died. '.$description2;
			case 8:
				return 'Everybody loves ' . $GV['name'] . ', except for whoever set ' . $GV['em'] . ' on fire last night. Now ' . $GV['name'] . ' is charcoal. '.$description2;
			case 9:
				return $GV['name'] . ' is baking cookies! Everyone comes over to ' . $GV['eir'] . ' house to taste ' . $GV['eir'] . ' yummy treats. But where is ' . $GV['name'] . '? And what\'s that funny smell coming from the oven? Uh oh! It looks like it\'s ' . $GV['name'] . '-flavored cookies now. '.$description2;
			case 10:
				return $GV['name'] . ' has always been small, but ' . $GV['e'] . ' used to be taller than 1cm. At this new size, ' . $GV['e'] . ' was easily swallowed by the pet kitten ' . $GV['e'] . ' got for ' . $GV['eir'] . ' birthday last week. What caused ' . $GV['em'] . ' to shrink anyway? '.$description2;
			case 11:
				return $GV['name'] . ' opens ' . $GV['eir'] . ' shoe locker and finds a love letter! ' . $GV['E'] . '\'d never received a love letter before! It says ' . $GV['eir'] . ' secret admirer will be waiting on the school rooftop. At the end of the day, ' . $GV['e'] . ' eagerly rushes to the roof, where ' . $GV['e'] . ' receives an axe to the face. '.$description2;
			}
		}
	}
	
	$this->custom_vars->yandere_themes[] = 'food';
	
