<?php
	
	require_once(dirname(__FILE__).'/yandere.php');
	
	class Yandere_theme_kde extends Yandere_theme_yandere
	{
		public function __construct ()
		{
			parent::__construct();
			
			$this->name = 'KDE';
			
			$this->game_name = 'The KDE Game';
			$this->game_name_full = 'the KDE Game';
			$this->game_name_specific = 'the KDE Game';
			$this->game_name_plural = 'KDE games';
			
			$this->generic_victims = array ();  // clear Shin-chan
			$this->generic_victims[] = array(
				'name' => 'Kate',
				'gender' => 'female',
			);
			$this->generic_victims[] = array(
				'name' => 'KWrite',
				'gender' => 'female',
			);
			$this->generic_victims[] = array(
				'name' => 'Quanta',
				'gender' => 'male',
			);
			$this->generic_victims[] = array(
				'name' => 'KWord',
				'gender' => 'male',
			);
			
			$this->rename_role(array (
				'baka ranger'       => 'hardware',
				'civilian'          => 'program',
				'cloaked psychic yandere' => 'obfuscated GNOME 2',
				'cloaked yandere'   => 'obfuscated GTK 2',
				'esper'             => 'Qt 2',
				'guardian'          => 'Konqueror 4',
				'hikikomori'        => 'Plasma',
				'idol'              => 'ANSI C',
				'nurse'             => 'Konqueror 3',
				'pedobear'          => 'Qt 3',
				'psychic yandere'   => 'GNOME 2',
				'ronin'             => 'Linux 2.4',
				'samurai'           => 'Linux 2.6',
				'sensei'            => 'GCC 4',
				'shogun'            => 'RISC Assembly',
				'spy'               => 'Qt 4',
				'stalker'           => 'C++',
				'tokokyohi'         => 'Kicker',
				'trap'              => 'QGtkStyle',
				'tsundere'          => 'gtk-engines-qt',
				'warrior'           => 'CISC Assembly',
				'yandere'           => 'GTK 2',
				'yandere doppelganger' => 'GTK 1',
				'yandere ronin'     => 'GNOME 1',
				'yandere spy'       => 'root GNOME 2',
			));
			
			foreach (array
			(
				'ANSI C' => '\\1 is ANSI C.',
				'Linux 2.4' => '\\2\\3 has been terminated by \\1.',
				'Linux 2.6' => '\\2\\3 has been terminated by \\1.',
				'GNOME 1' => '\\2\\3 has been terminated by \\1.',
			) as $k => $v)
				$this->action_messages[0][$k] = $v;
			
			foreach (array
			(
				'hardware' => 'Hardware has no stakes in the game. You win no matter who wins. Feel free to sabotage either side, and have fun with it. You don\'t have any special abilities.',  // baka ranger
				'program' => 'Programs are normal executables with no special abilities.',  // civilian
				'obfuscated GNOME 2' => 'Obfuscated GNOME 2 can inspect another program\'s role one time during a day of your choosing, and also don\'t give off a GTK-ish look. Type "\\3spy <user>" during the day or "\\3vote <user>" during the night.',  // cloaked psychic yandere
				'obfuscated GTK 2' => 'Obfuscated GTK 2 look like normal programs. Each night, you vote to kill someone by typing "\\3vote <user>". The majority vote among the worms wins. Earlier votes break ties.',  // cloaked yandere
				'Qt 2' => 'Qt 2 can inspect another program\'s role one time during a day of your choosing. Type "\\3spy <user>". Be careful of disguised roles like QGtkStyle and gtk-engines-qt which will be misreported.',  // esper
				'Konqueror 4' => 'Konqueror 4 have the ability to protect a program from any danger during the night. Type "\\3guard <user>". But be careful: if you protect a GTK, it will also attack you!',  // guardian
				'Plasma' => 'Plasma can hide every night, keeping safe from any killers. Type "\\3hide" during the night.',  // hikikomori
				'ANSI C' => 'ANSI C can type "\\3reveal" to prove to everyone that it\'s ANSI C.',  // idol
				'Qt 3' => 'Qt 3 can scare programs (they look like GTK), but they\'re on the good side. Every day, he can spy on anyone he wants by typing "\\3spy <user>".',  // pedobear
				'GNOME 2' => 'GNOME 2 can inspect another program\'s role one time during a day of your choosing. Type "\\3spy <user>" during the day or "\\3vote <user>" during the night.',  // root worm
				'Linux 2.4' => 'Linux 2.4 has the ability to single-handedly kill a program of their choosing once during a night or day of your choosing. Type "\\3kill <user>" if you believe that person is a worm.',  // samurai
				'GCC 4' => 'GCC 4 can upgrade any other program once during the day by typing "\\3upgrade <user>".',  // sensei
				'Qt 4' => 'Qt 4 can inspect another player\'s role each night. Type "\\3spy <user>". Be careful of disguised roles like QGtkStyle and gtk-engines-qt which will be misreported.',  // spy
				'C++' => 'C++ can learn where another program goes during the night. Each night, type "\\3stalk <user>". Although you can see a program\'s target, you can\'t see what action the program is performing on that target.',  // stalker
				'QGtkStyle' => 'QGtkStyle are normal programs with no special abilities, except you only win if the GTK win. You want to sabotage the game in favor of the GTK. Spies will mistake you for another program.',  // trap
				'gtk-engines-qt' => 'gtk-engines-qt are normal programs with no special abilities, except spies will mistake them for GTKs.',  // tsundere
				'CISC Assembly' => 'CISC Assembly have the ability to single-handedly kill a player of their choosing once during a night of your choosing. Type "\\3kill <user>" if you believe that person is a GTK.',  // warrior
				'GTK 2' => 'GTK 2 are the villains of the game. Each night, you vote to kill someone by typing "\\3vote <user>". The majority vote among the GTK wins. Earlier votes break ties.',  // yandere
				'GTK 1' => 'GTK 1 are GTK that can be safely guarded. Each night, you vote to kill someone by typing "\\3vote <user>". The majority vote among the GTK wins. Earlier votes break ties.',  // yandere doppelganger
				'root GNOME 2' => 'Root GNOME 2 are GTK that can inspect another program\'s role each day. Type "\\3spy <user>" during the day or "\\3vote <user>" during the night.',  // yandere spy
			) as $k => $v)
				$this->role_descriptions[$k] = $v;
			
			$this->weapons = array
			(
				'the Trash',
				'a core dump',
				'a segmentation fault',
				'a critical error',
				'an error',
				'a fork bomb',
				'the OOM killer',
				'a resource limit',
				'corrupt memory',
				'a CPU bug',
				'a hardware malfunction',
				'a PEBKAC',
				'a user error',
				'a shorted circuit',
				'a spill',
				'radiation',
				'the PC speaker\'s magnetic field',
				'a DVD laser',
				'a brownout',
				'a surge',
				'a loud pop',
				'a division by zero',
				'a floating-point error',
			);
			
			$this->murder_descriptions = array
			(
				'has been brutally terminated by',
				'is terminated, killed by',
				'was taken out by',
				'has been killed by',
				'has been terminated by',
				'is missing, terminated by',
				'has been savagely killed by',
				'was assassinated with',
				'was eliminated by',
				'was knocked off with',
				'has been shutdown by',
				'was wasted by',
				'was done in by',
			);
			
			$this->command_remaps = array_merge($this->command_remaps, array
			(
				'verify'    => 'reveal',
				'terminate' => 'kill|vote',
				'scan'      => 'spy',
			)
			);
		}
		
		public function get_introduction ($phase)
		{
			$GV = $this->generic_victim();
			
			$description1 .= $this->describe_death(null, false).'. ';
			
			switch (mt_rand(0, 2))
			{
			case 0:
				$description2 = 'This looks like the work of a '.$this->get_standard_role('mafioso').'!';
				break;
			
			case 1:
				$description2 = 'There\'s only one explanation: there is a '.$this->get_standard_role('mafioso').' among us!';
				break;
			
			case 2:
				$description2 = $GV['E'] . ' seems to have been the victim of a '.$this->get_standard_role('mafioso').'!';
				break;
			}
			
			switch (mt_rand(0, 4))
			{
			case 0:
				return 'Windows was always a corrupt OS. But last night it was confirmed when the system began getting slower and slower. Overnight, ' . $GV['name'] . ' '.$description1.$description2;
			case 1:
				return 'All the programs go about their business one day and notice that ' . $GV['name'] . ' seems to be missing. After executing for a while, they go to ' . $GV['eir'] . ' directory to check on ' . $GV['em'] . ', and find that ' . $GV['e'] . ' '.$description1.$description2;
			case 2:
				return 'At '.mt_rand(2, 4).':'.str_pad(mt_rand(0, 59), 2, '0', STR_PAD_LEFT).' in the morning, the computer wakes up to an illegal opcode. It\'s coming from the direction of ' . $GV['name'] . '! You all run to ' . $GV['eir'] . ' directory and find that ' . $GV['e'] . ' '.$description1.$description2;
			case 3:
				return 'Today is ' . $GV['name'] . '\'s turn to get used! And ' . $GV['e'] . '\'s been planning on this for quite some time now! All the libraries eagerly link, but they\'re met with a surprise: ' . $GV['name'] . ' '.$description1.$description2;
			case 4:
				return $GV['name'] . ' is a quiet, insignificant program. But ' . $GV['e'] . '\'s especially quiet today, because ' . $GV['e'] . ' '.$description1.$description2;
			}
		}
	}
	
	$this->custom_vars->yandere_themes[] = 'KDE';
	
?>
