<?php
	
	require_once(dirname(__FILE__).'/yandere.php');
	
	class Yandere_theme_smilie extends Yandere_theme_yandere
	{
		public function __construct ()
		{
			parent::__construct();
			
			$this->name = 'Smilie';
			
			$this->game_name = 'The smilie game';
			$this->game_name_full = 'the smilie game';
			$this->game_name_specific = 'the smilie game';
			$this->game_name_plural = 'smilie games';
			
			$this->generic_victims = array ();  // clear Shin-chan
			$this->generic_victims[] = array(
				'name' => 'x.X',
				'gender' => 'male',
			);
			$this->generic_victims[] = array(
				'name' => 'x.x',
				'gender' => 'female',
			);
			$this->generic_victims[] = array(
				'name' => 'X.x',
				'gender' => 'male',
			);
			$this->generic_victims[] = array(
				'name' => 'X.X',
				'gender' => 'female',
			);
			
			$this->rename_role(array (
				'baka ranger'             => '=P',
				'civilian'                => ':(',
				'cloaked ninja'           => ':\\',
				'cloaked psychic yandere' => ':D',
				'cloaked yandere'         => ':)',
				'esper'                   => ':^',
				'guardian'                => ':P',
				'hikikomori'              => ':S',
				'idol'                    => ':>',
				'magical girl'            => ';)',
				'ninja'                   => ':/',
				'pedobear'                => ';]',
				'psychic yandere'         => '=]',
				'samurai'                 => '=|',
				'sensei'                  => ':?',
				'shrine maiden'           => '=S',
				'spy'                     => ':O',
				'stalker'                 => '=O',
				'tank soldier'            => '=(',
				'trap'                    => ':]',
				'tsundere'                => ':[',
				'warrior'                 => ':|',
				'yandere'                 => '=)',
				'yandere doppelganger'    => 'XD',
				'yandere spy'             => '=D',
			));
			
			foreach (array
			(
				':>' => '\\1 :>',
				';)' => '\\1 ;) -- \\2\\3 is gone.',
				'=|' => '\\1 :| -- \\2\\3 is gone.',
				'=(' => '\\1 =( -- \\2\\3 is gone.',
			) as $k => $v)
				$this->action_messages[0][$k] = $v;
			
			foreach (array
			(
				'=P' => 'You win no matter who wins. Feel free to sabotage either side, and have fun with it. You on\'t have any special abilities. =P',  // baka ranger
				':(' => ':(',  // civilian
				':\\' => 'Either spy on someone once during a day of your choosing OR kill someone once during a night. Type "\\3spy <user>" during the day or "\\3kill <user>" during the night. :\\',  // cloaked ninja
				':D' => 'You can inspect another player\'s role one time during a day of your choosing, and also look like :/ to spies. Type "\\3spy <user>" during the day or "\\3vote <user>" during the night. :D',  // cloaked psychic yandere
				':)' => 'You look like :( to spying roles. Each night, you vote to kill someone by typing "\\3vote <user>". The majority vote among the grins wins. Earlier votes break ties. :)',  // cloaked yandere
				':^' => 'Inspect another program\'s role one time during a day of your choosing. Type "\\3spy <user>". Be careful of disguised roles like :] and :[ which will be misreported. :^',  // esper
				':P' => 'Protect a program from any danger during the night. Type "\\3guard <user>". But be careful: if you protect a grin, it will also attack you! :P',  // guardian
				':S' => 'Hide during a night of your choosing, keeping safe from any killers that night. Type "\\3hide" during the night. :S',  // hikikomori
				':>' => 'At any time during a day of your choice, you can type "\\3reveal" to prove to everyone that you\'re a :>',  // idol
				';)' => 'Either kill someone once during a day of your choosing OR guard someone once during a night. Type "\\3kill <user>" during the day or "\\3guard <user>" during the night. ;)',  // magical girl
				':/' => 'Either spy on someone once during a day of your choosing OR kill someone once during a night. Type "\\3spy <user>" during the day or "\\3kill <user>" during the night. :/',  // ninja
				';]' => 'Every day, spy on anyone you want by typing "\\3spy <user>". ;]',  // pedobear
				'=]' => 'Inspect another program\'s role one time during a day of your choosing. Type "\\3spy <user>" during the day or "\\3vote <user>" during the night. ;]',  // psychic yandere
				'=|' => 'Kill a program of your choosing once during a night or day of your choosing. Type "\\3kill <user>" if you believe that person is a grin. =|',  // samurai
				'=S' => 'Spy once during a day of your choosing OR guard once during a night. Type "\\3spy <user>" during the day or "\\3guard <user>" during the night. =S',  // shrine maiden
				':O' => 'Inspect another player\'s role each night. Type "\\3spy <user>". Be careful of disguised roles like :] and :[ which will be misreported. :O',  // spy
				'=O' => 'Stalk a player during the night. Each night, type "\\3stalk <user>". Although you can see a player\'s target, you can\'t see what action the player is performing on that target. =O',  // stalker
				'=(' => 'Kill anyone you want at any time, once per day and once per night if you want. But remember, you\'re trying to kill the grins. Type "\\3kill <user>". =(',  // tank soldier
				':]' => 'You have no special abilities, but you only win if the grins win. You want to sabotage the game in favor of the grins. Spying roles will mistake you for a :( ... :]',  // trap
				':[' => 'You have no special abilities, except spying roles will mistake you for a grin. :[',  // tsundere
				':|' => 'Kill a player of your choosing once during a night of your choosing. Type "\\3kill <user>" if you believe that person is a grin. :|',  // warrior
				'=)' => 'You are the villain of the game. Each night, you vote to kill someone by typing "\\3vote <user>". The majority vote among the grins wins. Earlier votes break ties. =)',  // yandere
				'XD' => 'You\'re a grin that can be safely guarded. Each night, you vote to kill someone by typing "\\3vote <user>". The majority vote among the yanderes wins. Earlier votes break ties. XD',  // yandere doppelganger
				'=D' => 'You\'re a grin that can inspect another player\'s role each day. Type "\\3spy <user>" during the day or "\\3vote <user>" during the night. =D',  // yandere spy
			) as $k => $v)
				$this->role_descriptions[$k] = $v;
			
			$this->weapons = array
			(
				'a program',
				'a poem',
				'a word',
				'a letter',
				'an error',
				'a number',
				'a symbol',
				'a tilde',
				'corrupt memory',
				'a bracket',
				'a brace',
				'a parenthesis',
				'an asterisk',
				'a zero',
				'a bad pixel',
				'a bad sector',
				'the PC speaker\'s magnetic field',
				'a DVD laser',
				'a brownout',
				'a surge',
				'a loud pop',
				'a division by zero',
				'a floating-point error',
				'a typo',
			);
			
			$this->murder_descriptions = array
			(
				'was replaced with',
				'was deleted by',
				'was modified by',
				'has been replaced with',
				'has been deleted by',
				'is missing, removed by',
				'has been modified by',
				'was edited with',
				'was eliminated by',
				'was knocked off with',
				'has been moved by',
				'was wasted by',
				'was done in by',
			);
		}
		
		public function get_introduction ($phase)
		{
			$GV = $this->generic_victim();
			
			$description1 .= $this->describe_death(null, false).'. ';
			
			switch (mt_rand(0, 2))
			{
			case 0:
				$description2 = 'This looks like the work of a '.$this->get_standard_role('mafioso').'!';
				break;
			
			case 1:
				$description2 = 'There\'s only one explanation: there is a '.$this->get_standard_role('mafioso').' among us!';
				break;
			
			case 2:
				$description2 = $GV['E'] . ' seems to have been the victim of a '.$this->get_standard_role('mafioso').'!';
				break;
			}
			
			switch (mt_rand(0, 4))
			{
			case 0:
				return 'Windows was always a corrupt OS. But last night it was confirmed when the system began getting slower and slower. Overnight, ' . $GV['name'] . ' '.$description1.$description2;
			case 1:
				return 'All the programs go about their business one day and notice that ' . $GV['name'] . ' seems to be missing. After executing for a while, they go to ' . $GV['eir'] . ' directory to check on ' . $GV['em'] . ', and find that ' . $GV['e'] . ' '.$description1.$description2;
			case 2:
				return 'At '.mt_rand(2, 4).':'.str_pad(mt_rand(0, 59), 2, '0', STR_PAD_LEFT).' in the morning, the computer wakes up to an illegal opcode. It\'s coming from the direction of ' . $GV['name'] . '! You all run to ' . $GV['eir'] . ' directory and find that ' . $GV['e'] . ' '.$description1.$description2;
			case 3:
				return 'Today is ' . $GV['name'] . '\'s turn to get used! And ' . $GV['e'] . '\'s been planning on this for quite some time now! All the libraries eagerly link, but they\'re met with a surprise: ' . $GV['name'] . ' '.$description1.$description2;
			case 4:
				return $GV['name'] . ' is a quiet, insignificant program. But ' . $GV['e'] . '\'s especially quiet today, because ' . $GV['e'] . ' '.$description1.$description2;
			}
		}
	}
	
	$this->custom_vars->yandere_themes[] = 'TWG';
	
?>
