<?php
	
	require_once(dirname(__FILE__).'/yandere.php');
	
	class Yandere_theme_twg extends Yandere_theme_yandere
	{
		public function __construct ()
		{
			parent::__construct();
			
			$this->name = 'TWG';
			
			$this->game_name = 'The Worm Game';
			$this->game_name_full = 'the Worm Game';
			$this->game_name_specific = 'the Worm Game';
			$this->game_name_plural = 'worm games';
			
			$this->generic_victims = array ();  // clear Shin-chan
			$this->generic_victims[] = array(
				'name' => 'Notepad',
				'gender' => 'male',
			);
			$this->generic_victims[] = array(
				'name' => 'KWrite',
				'gender' => 'female',
			);
			$this->generic_victims[] = array(
				'name' => 'gedit',
				'gender' => 'male',
			);
			$this->generic_victims[] = array(
				'name' => 'TextEdit',
				'gender' => 'female',
			);
			
			$this->rename_role(array (
				'baka ranger'       => 'hardware',
				'civilian'          => 'program',
				'cloaked psychic yandere' => 'obfuscated root worm',
				'cloaked yandere'   => 'obfuscated worm',
				'esper'             => 'top',
				'guardian'          => 'firewall',
				'hikikomori'        => 'mutex',
				'idol'              => 'signed program',
				'nurse'             => 'obscurity',
				'pedobear'          => 'hacker',
				'psychic yandere'   => 'root worm',
				'ronin'             => 'kill -9',
				'samurai'           => 'killall -9',
				'sensei'            => 'patch',
				'shogun'            => 'killall',
				'spy'               => 'virus scanner',
				'stalker'           => 'ptrace',
				'tokokyohi'         => 'flock',
				'trap'              => 'backdoor',
				'tsundere'          => 'radmin',
				'warrior'           => 'kill',
				'yandere'           => 'worm',
				'yandere doppelganger' => 'benign worm',
				'yandere ronin'     => 'infected kill -9',
				'yandere spy'       => 'infected virus scanner',
			));
			
			$this->role_plurals += array
			(
				'hardware' => 'hardware',
			);
			
			foreach (array
			(
				'signed program' => 'The computer\'s TPM module wakes up and verifies \\1\'s signature! \\1 is a verifiable signed program!',
				'cron job' => 'The system cron daemon calls upon \\1. \\1 immediately terminates \\2! \\2\\3 is no longer.',
				'kill -9' => '\\1 activates and sends SIGKILL to \\2! \\2\\3 is forcefully terminated.',
				'killall' => '\\1 activates and terminates \\2. \\2\\3 has been killall\'d.',
			) as $k => $v)
				$this->action_messages[0][$k] = $v;
			
			foreach (array
			(
				'hardware' => 'Hardware has no stakes in the game. You win no matter who wins. Feel free to sabotage either side, and have fun with it. You don\'t have any special abilities.',  // baka ranger
				'program' => 'Programs are normal executables with no special abilities.',  // civilian
				'obfuscated root worm' => 'Obfuscated root worms are worms that can inspect another program\'s role one time during a day of your choosing, and also look like mere bugs to virus scanners. Type "\\3spy <user>" during the day or "\\3vote <user>" during the night.',  // cloaked psychic yandere
				'obfuscated worm' => 'Obfuscated worms are worms that look like normal programs to virus scanners. Each night, you vote to kill someone by typing "\\3vote <user>". The majority vote among the worms wins. Earlier votes break ties.',  // cloaked yandere
				'top' => 'Top can inspect another program\'s role one time during a day of your choosing. Type "\\3spy <user>". Be careful of disguised roles like backdoors and radmins which will be misreported.',  // esper
				'firewall' => 'Firewalls have the ability to protect a program from any danger during the night. Type "\\3guard <user>". But be careful: if you protect a worm, the worm will also attack you!',  // guardian
				'mutex' => 'Mutexs can choose to lock during a night of your choosing, keeping safe from any killers that night. Type "\\3lock" during the night.',  // hikikomori
				'signed program' => 'Signed programs can be verified! At any time during a day of your choice, you can type "\\3reveal" to prove to everyone that you\'re a signed program.',  // idol
				'hacker' => 'Hackers scare programs (they looks like worms), but they\'re on the good side, because that\'s where the most programs are. Every day, he can spy on anyone he wants by typing "\\3spy <user>".',  // pedobear
				'root worm' => 'Worms running as root are worms that can inspect another program\'s role one time during a day of your choosing. Type "\\3spy <user>" during the day or "\\3vote <user>" during the night.',  // root worm
				'kill -9' => 'Kill -9 have the ability to single-handedly kill a program of their choosing once during a night or day of your choosing. Type "\\3kill <user>" if you believe that person is a worm.',  // samurai
				'patch' => 'A patch can upgrade any other program once during the day by typing "\\3upgrade <user>".',  // sensei
				'virus scanner' => 'Virus scanners can inspect another player\'s role each night. Type "\\3spy <user>". Be careful of disguised roles like backdoors and radmins which will be misreported.',  // spy
				'ptrace' => 'Ptraces can learn where another program goes during the night. Each night, type "\\3stalk <user>". Although you can see a program\'s target, you can\'t see what action the program is performing on that target.',  // stalker
				'backdoor' => 'Backdoors are normal programs with no special abilities, except you only win if the worms win. You want to sabotage the game in favor of the worms. Virus scanners will mistake you for a civilian.',  // trap
				'radmin' => 'Remote administrators are normal users with no special abilities, except virus scanners will mistake them for worms.',  // tsundere
				'kill' => 'Kill programs have the ability to single-handedly kill a player of their choosing once during a night of your choosing. Type "\\3kill <user>" if you believe that person is a worm.',  // warrior
				'worm' => 'Worms are the villains of the game. Each night, you vote to kill someone by typing "\\3vote <user>". The majority vote among the worms wins. Earlier votes break ties.',  // yandere
				'benign worm' => 'Benign worms are worms that can be safely guarded. Each night, you vote to kill someone by typing "\\3vote <user>". The majority vote among the worms wins. Earlier votes break ties.',  // yandere doppelganger
				'infected virus scanner' => 'Infected virus scanners are worms that can inspect another program\'s role each day. Type "\\3spy <user>" during the day or "\\3vote <user>" during the night.',  // yandere spy
			) as $k => $v)
				$this->role_descriptions[$k] = $v;
			
			$this->weapons = array
			(
				'the Trash',
				'a core dump',
				'a segmentation fault',
				'a critical error',
				'an error',
				'a fork bomb',
				'the OOM killer',
				'a resource limit',
				'corrupt memory',
				'a CPU bug',
				'a hardware malfunction',
				'a PEBKAC',
				'a user error',
				'a shorted circuit',
				'a spill',
				'radiation',
				'the PC speaker\'s magnetic field',
				'a DVD laser',
				'a brownout',
				'a surge',
				'a loud pop',
				'a division by zero',
				'a floating-point error',
			);
			
			$this->murder_descriptions = array
			(
				'has been brutally terminated by',
				'is terminated, killed by',
				'was taken out by',
				'has been killed by',
				'has been terminated by',
				'is missing, terminated by',
				'has been savagely killed by',
				'was assassinated with',
				'was eliminated by',
				'was knocked off with',
				'has been shutdown by',
				'was wasted by',
				'was done in by',
			);
			
			$this->command_remaps = array_merge($this->command_remaps, array
			(
				'lock'      => 'hide',
				'verify'    => 'reveal',
				'terminate' => 'kill|vote',
				'scan'      => 'spy',
			)
			);
		}
		
		public function get_introduction ($phase)
		{
			$GV = $this->generic_victim();
			
			$description1 .= $this->describe_death(null, false).'. ';
			
			switch (mt_rand(0, 2))
			{
			case 0:
				$description2 = 'This looks like the work of a '.$this->get_standard_role('mafioso').'!';
				break;
			
			case 1:
				$description2 = 'There\'s only one explanation: there is a '.$this->get_standard_role('mafioso').' among us!';
				break;
			
			case 2:
				$description2 = $GV['E'] . ' seems to have been the victim of a '.$this->get_standard_role('mafioso').'!';
				break;
			}
			
			switch (mt_rand(0, 4))
			{
			case 0:
				return 'Windows was always a corrupt OS. But last night it was confirmed when the system began getting slower and slower. Overnight, ' . $GV['name'] . ' '.$description1.$description2;
			case 1:
				return 'All the programs go about their business one day and notice that ' . $GV['name'] . ' seems to be missing. After executing for a while, they go to ' . $GV['eir'] . ' directory to check on ' . $GV['em'] . ', and find that ' . $GV['e'] . ' '.$description1.$description2;
			case 2:
				return 'At '.mt_rand(2, 4).':'.str_pad(mt_rand(0, 59), 2, '0', STR_PAD_LEFT).' in the morning, the computer wakes up to an illegal opcode. It\'s coming from the direction of ' . $GV['name'] . '! You all run to ' . $GV['eir'] . ' directory and find that ' . $GV['e'] . ' '.$description1.$description2;
			case 3:
				return 'Today is ' . $GV['name'] . '\'s turn to get used! And ' . $GV['e'] . '\'s been planning on this for quite some time now! All the libraries eagerly link, but they\'re met with a surprise: ' . $GV['name'] . ' '.$description1.$description2;
			case 4:
				return $GV['name'] . ' is a quiet, insignificant program. But ' . $GV['e'] . '\'s especially quiet today, because ' . $GV['e'] . ' '.$description1.$description2;
			}
		}
	}
	
	$this->custom_vars->yandere_themes[] = 'TWG';
	
?>
