<?php
	
	class Yandere_theme_werewolf extends Yandere_theme
	{
		public function __construct ()
		{
			$this->name = 'Werewolf';
			
			$this->game_name = 'werewolf';
			$this->game_name_full = 'a werewolf game';
			$this->game_name_specific = 'the werewolf game';
			$this->game_name_plural = 'werewolf games';
			
			$this->generic_victims[] = array(
				'name' => 'John Doe',
				'gender' => 'male',
			);
			$this->generic_victims[] = array(
				'name' => 'Jane Doe',
				'gender' => 'female',
			);
			
			$this->role_plurals += array
			(
				'seer' => 'seers',
				'villager' => 'villagers',
				'werewolf' => 'werewolves',
			);
			
			$this->standard_roles += array
			(
				'innocent' => 'villager',
				'mafioso' => 'werewolf',
				'detective' => 'seer',
			);
			
			$this->role_actions[0] += array // Day
			(
			);
			$this->role_actions[1] += array // Night
			(
				'seer' => 'spy',
				'wolfsbane' => 'hide', // hide OR guard, when supported
				'vigilante' => 'kill',
				'werewolf' => 'vote',
			);
			
			$this->action_messages[0] += array
			(
			);
			
			$this->enemy_roles = array_merge($this->enemy_roles, array
			(
				'werewolf',
			)
			);
			
			$this->always_win_roles = array_merge($this->always_win_roles, array
			(
			)
			);
			
			$this->yandere_role_odds += array
			(
				'werewolf' => 100,
			);
			
			$this->role_odds += array
			(
				'villager' => 85,
				'vigilante' => 10,
				'wolfsbane' => 8,
			);
			
			$this->single_use_roles = array_merge($this->single_use_roles, array
			(
				'vigilante',
			)
			);
			
			$this->role_appearances += array
			(
			);
			
			$this->role_descriptions += array
			(
				'villager' => 'Villagers are normal townsfolk with no special abilities.',
				'wolfsbane' => 'Villagers with wolfsbane have the ability to protect a player from any danger during the night. Type "\\3guard <user>" or "\\3hide" to protect yourself. But be careful: if you protect a werewolf, that werewolf will also attack you!',
				'seer' => 'Seers can inspect another player\'s role each night. Type "\\3spy <user>".',
				'vigilante' => 'Vigilantes have the ability to single-handedly kill a player of their choosing once during a night of your choosing. Type "\\3kill <user>" if you believe that person is a werewolf.',
				'werewolf' => 'Werewolves are the villains of the game. Each night, you vote to kill someone by typing "\\3vote <user>". The majority vote among the werewolves wins. Earlier votes break ties.',
			);
			
			$this->weapons = array_merge($this->weapons, array
			(
				'a crowbar',
				'an axe',
				'a sword',
				'dynamite',
				'a wrench',
				'dihydrogen monoxide',
				'a machine gun',
				'a sledgehammer',
				'a giant snake',
				'a bowling ball',
				'a cannon',
				'laser beams',
				'a thermal detonator',
				'fire',
				'poison cake',
				'a rock',
				'a silver bullet',
			)
			);
			
			$this->murder_descriptions = array_merge($this->murder_descriptions, array
			(
				'has been brutally murdered by',
				'is dead, killed by',
				'was taken out by',
				'has been killed by',
				'has been murdered by',
				'is lying on the floor, murdered by',
				'has been savagely killed by',
				'was assassinated with',
				'was eliminated by',
				'was knocked off with',
				'has been slain by',
				'was wasted by',
				'was done in by',
			)
			);
		}
		
		public function get_introduction ($phase)
		{
			$GV = $this->generic_victim();
			
			$description1 .= $this->describe_death(null, false).'. ';
			
			switch (mt_rand(0, 2))
			{
			case 0:
				$description2 = 'This looks like the work of a '.$this->get_standard_role('mafioso').'!';
				break;
			
			case 1:
				$description2 = 'There\'s only one explanation: there is a '.$this->get_standard_role('mafioso').' among us!';
				break;
			
			case 2:
				$description2 = $GV['E'] . ' seems to have been the victim of a '.$this->get_standard_role('mafioso').'!';
				break;
			}
			
			switch (mt_rand(0, 12))
			{
			case 0:
				return 'Oh, no!! The village wakes up one morning to a horrible surprise: ' . $GV['name'] . ' '.$description1.$description2;
			case 1:
				return 'All the little children go to school one day and notice that ' . $GV['name'] . ' seems to be missing. The parents all go to ' . $GV['eir'] . ' house to check on ' . $GV['em'] . ', and find that ' . $GV['e'] . ' '.$description1.$description2;
			case 2:
				return 'At '.mt_rand(2, 4).':'.str_pad(mt_rand(0, 59), 2, '0', STR_PAD_LEFT).' in the morning, the neighborhood wakes up to a scream. It sounds like ' . $GV['name'] . '! You all run to ' . $GV['eir'] . ' room and find that ' . $GV['e'] . ' '.$description1.$description2;
			case 3:
				return 'Today is ' . $GV['name'] . '\'s birthday! And ' . $GV['e'] . '\'s having ice cream cake! All the townspeople eagerly come to ' . $GV['eir'] . ' house, but they\'re met with a surprise: ' . $GV['name'] . ' '.$description1.$description2;
			case 4:
				return $GV['name'] . ' is a quiet, moe fellow. But ' . $GV['e'] . '\'s especially quiet today, because ' . $GV['e'] . ' '.$description1.$description2;
			case 5:
				return 'It\'s Christmas morning! ' . $GV['name'] . ' rushes into the living room and sees a great big present with ' . $GV['eir'] . ' name on it. Full of excitement, ' . $GV['e'] . ' rips open the box and finds some sort of weird alarm clock attached to several red sticks. It proceeds to explode. '.$description2;
			case 6:
				return $GV['name'] . ' is riding merrily on the bus on ' . $GV['eir'] . ' way to school. Little does ' . $GV['e'] . ' know it\'s rigged with hundreds of explosives. The bus explodes in a mighty inferno, and ' . $GV['name'] . ' bits go flying everywhere. '.$description2;
			case 7:
				return 'All ' . $GV['eir'] . ' life, ' . $GV['name'] . ' had been plagued by an illness that confined ' . $GV['em'] . ' to ' . $GV['eir'] . ' room. But today, ' . $GV['e'] . ' decided to fulfill ' . $GV['eir'] . ' dream: to risk it and go to school like all the other kids. But ' . $GV['eir'] . ' lunch was poisoned and ' . $GV['e'] . ' died. '.$description2;
			case 8:
				return 'Everybody loves ' . $GV['name'] . ', except for whoever set ' . $GV['em'] . ' on fire last night. Now ' . $GV['name'] . ' is charcoal. '.$description2;
			case 9:
				return $GV['name'] . ' is baking cookies! Everyone comes over to ' . $GV['eir'] . ' house to taste ' . $GV['eir'] . ' yummy treats. But where is ' . $GV['name'] . '? And what\'s that funny smell coming from the oven? Uh oh! It looks like it\'s ' . $GV['name'] . '-flavored cookies now. '.$description2;
			case 10:
				return $GV['name'] . ' has always been small, but ' . $GV['e'] . ' used to be taller than 1cm. At this new size, ' . $GV['e'] . ' was easily swallowed by the pet kitten ' . $GV['e'] . ' got for ' . $GV['eir'] . ' birthday last week. What caused ' . $GV['em'] . ' to shrink anyway? '.$description2;
			case 11:
				return $GV['name'] . ' opens ' . $GV['eir'] . ' shoe locker and finds a love letter! ' . $GV['E'] . '\'d never received a love letter before! It says ' . $GV['eir'] . ' secret admirer will be waiting on the school rooftop. At the end of the day, ' . $GV['e'] . ' eagerly rushes to the roof, where ' . $GV['e'] . ' receives an axe to the face. '.$description2;
			}
		}
	}
	
	$this->custom_vars->yandere_themes[] = 'werewolf';
	
?>
