<?php
	
	class Yandere_theme_yandere extends Yandere_theme
	{
		public function __construct ()
		{
			$this->name = 'Yandere';
			
			$this->game_name = 'yandere';
			$this->game_name_full = 'a yandere game';
			$this->game_name_specific = 'the yandere game';
			$this->game_name_plural = 'yandere games';
			
			$this->generic_victims[] = array(
				'name' => 'Shin-chan',
				'gender' => 'female',
			);
			$this->generic_victims[] = array(
				'name' => 'Hanako-chan',
				'gender' => 'female',
			);
			$this->generic_victims[] = array(
				'name' => 'Taro-kun',
				'gender' => 'male',
			);
			
			if (property_exists($this, 'role_upgrades'))
			{
			
			$this->role_upgrades += array
			(
				'civilian' => array('tokokyohi', 'warrior', 'esper', 'idol', 'witness', 'snoop', 'nurse'),
				'cloaked psychic yandere' => 'cloaked psychic yandere doppelganger with a top hat',
				'cloaked yandere' => 'cloaked psychic yandere',
				'esper' => 'spy',
				'idol' => array('ronin', 'sensei'),
				'nurse' => 'guardian',
				'psychic yandere' => array('cloaked psychic yandere', 'yandere spy'),
				'ronin' => 'samurai',
				'sensei' => 'shisho',
				'snoop' => 'detective',
				'tokokyohi' => 'hikikomori',
				'trap' => array('baka ranger', 'cloaked yandere'),
				'tsundere' => array('civilian', 'snoop'),
				'warrior' => array('shogun', 'ronin'),
				'witness' => 'stalker',
				'yandere' => array('cloaked yandere', 'psychic yandere', 'yandere doppelganger', 'yandere spy', 'yandere ronin', 'yandere senpai'),
				'yandere doppelganger' => 'cloaked yandere',
			);
			
			$this->role_reveal_as += array
			(
				'cloaked psychic yandere' => 'guardian',
				'cloaked psychic yandere doppelganger with a top hat' => 'guardian',
				'yandere ronin' => 'samurai',
				'yandere senpai' => 'shisho',
				'yandere spy' => 'spy',
			);
			
			$this->role_odds['sensei'] = 10;
			$this->role_odds['shisho'] = 3;
			
			}
			
			$this->role_plurals += array
			(
				'baka ranger' => 'baka rangers',
				'civilian' => 'civilians',
				'cloaked psychic yandere' => 'cloaked psychic yanderes',
				'cloaked psychic yandere doppelganger with a top hat' => 'cloaked psychic yandere doppelgangers with top hats',
				'cloaked yandere' => 'cloaked yanderes',
				'esper' => 'espers',
				'guardian' => 'guardians',
				'hikikomori' => 'hikikomoris',
				'idol' => 'idols',
				'nurse' => 'nurses',
				'psychic yandere' => 'psychic yanderes',
				'ronin' => 'ronin',
				'samurai' => 'samurai',
				'sensei' => 'sensei-tachi',
				'shisho' => 'shisho-tachi',
				'shogun' => 'shoguns',
				'spy' => 'spies',
				'stalker' => 'stalkers',
				'tokokyohi' => 'tokokyohi',
				'trap' => 'traps',
				'tsundere' => 'tsunderes',
				'warrior' => 'warriors',
				'witness' => 'witnesses',
				'yandere' => 'yanderes',
				'yandere doppelganger' => 'yandere doppelgangers',
				'yandere ronin' => 'yandere ronin',
				'yandere senpai' => 'yandere senpai-tachi',
				'yandere spy' => 'yandere spies',
			);
			
			$this->standard_roles += array
			(
				'innocent' => 'civilian',
				'mafioso' => 'yandere',
				'detective' => 'spy',
				// FIXME: allow config selection of unique-special role, default to spy or random
			);
			
			$this->role_actions[0] += array // Day
			(
				'esper' => 'spy',
				'cloaked psychic yandere' => 'spy',
				'cloaked psychic yandere doppelganger with a top hat' => 'spy',
				'idol' => 'reveal',
				'psychic yandere' => 'spy',
				'ronin' => 'kill',
				'samurai' => 'kill',
				'sensei' => 'upgrade',
				'shisho' => 'upgrade',
				'yandere ronin' => 'kill',
				'yandere senpai' => 'upgrade',
				'yandere spy' => 'spy',
			);
			$this->role_actions[1] += array // Night
			(
				'cloaked psychic yandere' => 'vote',
				'cloaked psychic yandere doppelganger with a top hat' => 'vote',
				'cloaked yandere' => 'vote',
				'detective' => 'check',
				'guardian' => 'guard',
				'hikikomori' => 'hide',
				'nurse' => 'guard',
				'psychic yandere' => 'vote',
				'ronin' => 'kill',
				'shogun' => 'kill',
				'snoop' => 'check',
				'spy' => 'spy',
				'stalker' => 'stalk',
				'tokokyohi' => 'hide',
				'warrior' => 'kill',
				'witness' => 'stalk',
				'yandere' => 'vote',
				'yandere doppelganger' => 'vote',
				'yandere ronin' => 'vote',
				'yandere senpai' => 'vote',
				'yandere spy' => 'vote',
			);
			
			$this->action_messages[0] += array
			(
				'idol' => 'A limousine pulls up and the famous idol \\1 steps out! \\1 hands everyone autographed copies of the latest album, "I Want You Lovely".',
				'ronin' => '\\1 pulls out a katana and drives it through \\2\'s chest! \\2\\3 falls over and dies.',
				'samurai' => '\\1 pulls out a katana and drives it through \\2\'s chest! \\2\\3 falls over and dies.',
				'yandere ronin' => '\\1 pulls out a katana and drives it through \\2\'s chest! \\2\\3 falls over and dies.',
			);
			
			$this->enemy_roles = array_merge($this->enemy_roles, array
			(
				'cloaked yandere',
				'cloaked psychic yandere',
				'cloaked psychic yandere doppelganger with a top hat',
				'psychic yandere',
				'trap',
				'yandere',
				'yandere doppelganger',
				'yandere ronin',
				'yandere senpai',
				'yandere spy',
			)
			);
			
			$this->always_win_roles = array_merge($this->always_win_roles, array
			(
				'baka ranger',
			)
			);
			
			$this->yandere_role_odds += array
			(
				'yandere' => 50,
				
				'psychic yandere' => 15,
				
				'cloaked psychic yandere' => 5,
				'cloaked yandere' => 5,
				
				'yandere ronin' => 3,
				'yandere senpai' => 3,
				'yandere spy' => 2,
				
				'cloaked psychic yandere doppelganger with a top hat' => 2,
			);
			
			$this->role_odds += array
			(
				'tsundere' => 15,
				
				'trap' => 10,
				'civilian' => 180,
				
				'warrior' => 25,
				'esper' => 25,
				'tokokyohi' => 25,
				'idol' => 25,
				'nurse' => 25,
				'snoop' => 25,
				'witness' => 25,
				
				'ronin' => 10,
				
				'guardian' => 8,
				
				'samurai' => 3,
				'baka ranger' => 3,
				'detective' => 3,
				'hikikomori' => 3,
				'shogun' => 3,
				'spy' => 3,
				'stalker' => 3,
			);
			
			$this->single_use_roles = array_merge($this->single_use_roles, array
			(
				'cloaked psychic yandere',
				'cloaked psychic yandere doppelganger with a top hat',
				'esper',
				'idol',
				'psychic yandere',
				'nurse',
				'ronin',
				'sensei',
				'snoop',
				'tokokyohi',
				'warrior',
				'witness',
				'yandere ronin',
				'yandere senpai',
			)
			);
			
			$this->role_appearances += array
			(
				'cloaked psychic yandere' => 'esper',
				'cloaked psychic yandere doppelganger with a top hat' => 'esper',
				'cloaked yandere' => 'civilian',
				'snoop' => 'yandere',
				'detective' => 'yandere',
				'trap' => 'civilian',
				'tsundere' => 'yandere',
			);
			if (property_exists($this, 'role_appearances_multi') && $this->role_appearances_multi)
			{
			$this->role_appearances = array
			(
				'cloaked psychic yandere' => array('civilian', 'tokokyohi', 'hikikomori', 'nurse', 'guardian', 'warrior', 'esper', 'spy', 'shogun'),
				'cloaked psychic yandere doppelganger with a top hat' => array_keys($this->role_odds),
				'cloaked yandere' => array('civilian', 'tokokyohi', 'hikikomori', 'nurse', 'guardian', 'warrior', 'witness', 'stalker', 'shogun'),
				'detective' => array('yandere', 'yandere spy', 'yandere doppelganger', 'strawberry yandere'),
				'snoop' => array('yandere', 'psychic yandere', 'yandere doppelganger', 'vanilla yandere', 'yandere senpai'),
				'trap' => array('civilian', 'tokokyohi', 'hikikomori', 'nurse', 'guardian', 'warrior', 'witness', 'snoop', 'detective'),
				'tsundere' => array('yandere', 'psychic yandere', 'yandere ronin', 'yandere senpai', 'yandere doppelganger', 'chocolate yandere'),
			) + $this->role_appearances;
			}
			
			if (property_exists($this, 'guard_friendly'))
			{
			
			$this->guard_friendly = @array_merge($this->guard_friendly, array
			(
				'yandere doppelganger',
				'cloaked psychic yandere doppelganger with a top hat',
			)
			);
			
			$this->yandere_role_odds['yandere doppelganger'] = 15;
			
			}
			
			$this->role_descriptions += array
			(
				'baka ranger' => 'Baka rangers have no stakes in the game. You win no matter who wins. Feel free to sabotage either side, and have fun with it. You don\'t have any special abilities.',
				'civilian' => 'Civilians are normal townsfolk with no special abilities.',
				'cloaked psychic yandere' => 'Cloaked psychic yanderes are yanderes that can inspect another player\'s role one time during a day of your choosing, and also look like espers to spies. Type "\\3spy <user>" during the day or "\\3vote <user>" during the night.',
				'cloaked psychic yandere doppelganger with a top hat' => 'lolwtfbbq!',
				'cloaked yandere' => 'Cloaked yanderes are yanderes that look like civilians to spies. Each night, you vote to kill someone by typing "\\3vote <user>". The majority vote among the yanderes wins. Earlier votes break ties.',
				'detective' => 'Detectives look like yanderes, but can inspect another player\'s alignment each night. Type "\\3check <user>".',
				'esper' => 'Espers can inspect another player\'s role one time during a day of your choosing. Type "\\3spy <user>". Be careful of disguised roles like traps and tsunderes which will be misreported.',
				'guardian' => 'Guardians have the ability to protect a player from any danger during the night. Type "\\3guard <user>". But be careful: if you protect a yandere, the yandere will also attack you!',
				'hikikomori' => 'Hikikomoris can choose to hide each night, keeping safe from any killers. Type "\\3hide" during the night.',
				'idol' => 'Idols are famous! At any time during a day of your choice, you can type "\\3reveal" to prove to everyone that you\'re an idol.',
				'nurse' => 'Nurses have the ability to protect a player from any danger once during the night. Type "\\3guard <user>". But be careful: if you protect a yandere, the yandere will also attack you!',
				'psychic yandere' => 'Psychic yanderes are yanderes that can inspect another player\'s role one time during a day of your choosing. Type "\\3spy <user>" during the day or "\\3vote <user>" during the night.',
				'ronin' => 'Ronin have the ability to single-handedly kill a player of their choosing once during a night or day of your choosing. Type "\\3kill <user>" if you believe that person is a yandere.',
				'samurai' => 'Samurai have the ability to single-handedly kill a player of their choosing each day. Type "\\3kill <user>" if you believe that person is a yandere.',
				'sensei' => 'Sensei can upgrade any other player once during the day by typing "\\3upgrade <user>".',
				'shisho' => 'Shisho can upgrade any other player once each day by typing "\\3upgrade <user>".',
				'shogun' => 'Shoguns have the ability to single-handedly kill a player of their choosing each night. Type "\\3kill <user>" if you believe that person is a yandere.',
				'snoop' => 'Snoops look like yanderes, but can inspect another player\'s alignment one time during a night of your choosing. Type "\\3check <user>".',
				'spy' => 'Spies can inspect another player\'s role each night. Type "\\3spy <user>". Be careful of disguised roles like traps and tsunderes which will be misreported.',
				'stalker' => 'Stalkers can learn where another player goes during the night. Each night, type "\\3stalk <user>". Although you can see a player\'s target, you can\'t see what action the player is performing on that target.',
				'tokokyohi' => 'Tokokyohi can choose to hide during a night of your choosing, keeping safe from any killers that night. Type "\\3hide" during the night.',
				'trap' => 'Traps are normal civilians with no special abilities, except you only win if the yanderes win. You want to sabotage the game in favor of the yanderes. Spies will mistake you for a civilian.',
				'tsundere' => 'Tsunderes are normal civilians with no special abilities, except spies will mistake them for yanderes.',
				'warrior' => 'Warriors have the ability to single-handedly kill a player of their choosing once during a night of your choosing. Type "\\3kill <user>" if you believe that person is a yandere.',
				'witness' => 'A witness can learn where another player goes one time during the night of your choosing. When you wish, type "\\3stalk <user>". Although you can see a player\'s target, you can\'t see what action the player is performing on that target.',
				'yandere' => 'Yanderes are the villains of the game. Each night, you vote to kill someone by typing "\\3vote <user>". The majority vote among the yanderes wins. Earlier votes break ties.',
				'yandere doppelganger' => 'Yandere doppelgangers are yanderes that can be safely guarded. Each night, you vote to kill someone by typing "\\3vote <user>". The majority vote among the yanderes wins. Earlier votes break ties.',
				'yandere ronin' => 'Yandere ronin have the ability to single-handedly kill a player of their choosing once during a day of your choosing. Type "\\3kill <user>" if you want to kill that person, and "\\3vote <user>" each night.',
				'yandere senpai' => 'Yandere senpai have the ability to upgrade any other player once during the day by typing "\\3upgrade <user>". Use "\\3vote <user>" each night.',
				'yandere spy' => 'Yanderes spies are yanderes that can inspect another player\'s role each day. Type "\\3spy <user>" during the day or "\\3vote <user>" during the night.',
			);
			if (property_exists($this, 'role_appearances_multi') && $this->role_appearances_multi)
			{
			$this->role_descriptions = array
			(
				'cloaked psychic yandere' => 'Cloaked psychic yanderes are yanderes that can inspect another player\'s role one time during a day of your choosing, and also look like legitimate roles to spies. Type "\\3spy <user>" during the day or "\\3vote <user>" during the night.%appear%',
				'cloaked psychic yandere doppelganger with a top hat' => 'Cloaked psychic yandere doppelgangers with top hats are yanderes that can inspect another player\'s role one time during a day of your choosing, and also look like legitimate roles to spies AND can be guarded. Type "\\3spy <user>" during the day or "\\3vote <user>" during the night.%appear%',
				'cloaked yandere' => 'Cloaked yanderes are yanderes that look like legitimate roles to spies. Each night, you vote to kill someone by typing "\\3vote <user>". The majority vote among the yanderes wins. Earlier votes break ties.%appear%',
				'trap' => 'Traps are normal civilians with no special abilities, except you only win if the yanderes win. You want to sabotage the game in favor of the yanderes. Spies will mistake you for a legitimate role.%appear%',
			) + $this->role_descriptions;
			}
			
			$this->weapons = array_merge($this->weapons, array
			(
				'a crowbar',
				'an axe',
				'a sword',
				'dynamite',
				'a wrench',
				'a fork',
				'a giant plushie',
				'dihydrogen monoxide',
				'a machine gun',
				'a cheese grater',
				'a rolling pin',
				'a frying pan',
				'a staple gun',
				'a sledgehammer',
				'a major papercut',
				'a pineapple',
				'a box of gummy worms',
				'a giant snake',
				'excalibolg',
				'a pretzel',
				'a death note',
				'a mecha',
				'a bowling ball',
				'AIDS',
				'a tentacle monster',
				'a tennis racket',
				'an exploding pen',
				'a cannon',
				'laser beams',
				'a hot glue gun',
				'a frisby',
				'a mutant bee sting',
				'a shark',
				'a yo-yo',
				'ESP',
				'a yak',
				'a box of starving, crazed weasels',
				'a shuriken',
				'a banana',
				'a thermal detonator',
				'a falling house',
				'a Masamune',
				'a mouse trap',
				'a walrus with a top hat',
				'fire',
				'suicide',
				'cancer',
				'a hybrid vehicle',
				'lolipops',
				'poison cake',
				'a sugar overdose',
				'a Vulcan nerve pinch',
				'a rift in space-time',
				'the power of the void',
				'a rock',
				'a chicken gun',
				'the force',
				'a large hadron collider',
				'a silver bullet',
				'a carrier swarm',
			)
			);
			
			$this->murder_descriptions = array_merge($this->murder_descriptions, array
			(
				'has been brutally murdered by',
				'is dead, killed by',
				'was taken out by',
				'has been killed by',
				'has been murdered by',
				'is lying on the floor, murdered by',
				'has been savagely killed by',
				'was assassinated with',
				'was eliminated by',
				'was knocked off with',
				'has been slain by',
				'was wasted by',
				'was done in by',
			)
			);
		}
		
		public function get_introduction ($phase)
		{
			$GV = $this->generic_victim();
			
			$description1 .= $this->describe_death(null, false).'. ';
			
			switch (mt_rand(0, 2))
			{
			case 0:
				$description2 = 'This looks like the work of '.$this->role_singular($this->get_standard_role('mafioso')).'!';
				break;
			
			case 1:
				$description2 = 'There\'s only one explanation: there is '.$this->role_singular($this->get_standard_role('mafioso')).' among us!';
				break;
			
			case 2:
				$description2 = $GV['E'] . ' seems to have been the victim of '.$this->role_singular($this->get_standard_role('mafioso')).'!';
				break;
			}
			
			switch (mt_rand(0, 11))
			{
			case 0:
				return 'TAIHEN!! The village wakes up one morning to a horrible surprise: ' . $GV['name'] . ' '.$description1.$description2;
			case 1:
				return 'All the little children go to school one day and notice that ' . $GV['name'] . ' seems to be missing. After school, you go to ' . $GV['eir'] . ' house to check on ' . $GV['em'] . ', and find that ' . $GV['e'] . ' '.$description1.$description2;
			case 2:
				return 'At '.mt_rand(2, 4).':'.str_pad(mt_rand(0, 59), 2, '0', STR_PAD_LEFT).' in the morning, the neighborhood wakes up to a scream. It sounds like ' . $GV['name'] . '! You all run to ' . $GV['eir'] . ' room and find that ' . $GV['e'] . ' '.$description1.$description2;
			case 3:
				return 'Today is ' . $GV['name'] . '\'s birthday! And ' . $GV['e'] . '\'s having ichigo cake! All the townspeople eagerly come to ' . $GV['eir'] . ' house, but they\'re met with a surprise: ' . $GV['name'] . ' '.$description1.$description2;
			case 4:
				return $GV['name'] . ' is a quiet, moe fellow. But ' . $GV['e'] . '\'s especially quiet today, because ' . $GV['e'] . ' '.$description1.$description2;
			case 5:
				return 'It\'s Christmas morning! ' . $GV['name'] . ' rushes into the living room and sees a great big present with ' . $GV['eir'] . ' name on it. Full of excitement, ' . $GV['e'] . ' rips open the box and finds some sort of weird alarm clock attached to several red sticks. It proceeds to explode. '.$description2;
			case 6:
				return $GV['name'] . ' is riding merrily on the bus on ' . $GV['eir'] . ' way to school. Little does ' . $GV['e'] . ' know it\'s rigged with hundreds of explosives. The bus explodes in a mighty inferno, and ' . $GV['name'] . ' bits go flying everywhere. '.$description2;
			case 7:
				return 'All ' . $GV['eir'] . ' life, ' . $GV['name'] . ' had been plagued by an illness that confined ' . $GV['em'] . ' to ' . $GV['eir'] . ' room. But today, ' . $GV['e'] . ' decided to fulfill ' . $GV['eir'] . ' dream: to risk it and go to school like all the other kids. But ' . $GV['eir'] . ' lunch was poisoned and ' . $GV['e'] . ' died. '.$description2;
			case 8:
				return 'Everybody loves ' . $GV['name'] . ', except for whoever set ' . $GV['em'] . ' on fire last night. Now ' . $GV['name'] . ' is charcoal. '.$description2;
			case 9:
				return $GV['name'] . ' is baking cookies! Everyone comes over to ' . $GV['eir'] . ' house to taste ' . $GV['eir'] . ' yummy treats. But where is ' . $GV['name'] . '? And what\'s that funny smell coming from the oven? Uh oh! It looks like it\'s ' . $GV['name'] . '-flavored cookies now. '.$description2;
			case 10:
				return $GV['name'] . ' has always been small, but ' . $GV['e'] . ' used to be taller than 1cm. At this new size, ' . $GV['e'] . ' was easily swallowed by the pet kitten ' . $GV['e'] . ' got for ' . $GV['eir'] . ' birthday last week. What caused ' . $GV['em'] . ' to shrink anyway? '.$description2;
			case 11:
				return $GV['name'] . ' opens ' . $GV['eir'] . ' shoe locker and finds a love letter! ' . $GV['E'] . '\'d never received a love letter before! It says ' . $GV['eir'] . ' secret admirer will be waiting on the school rooftop. At the end of the day, ' . $GV['e'] . ' eagerly rushes to the roof, where ' . $GV['e'] . ' receives an axe to the face. '.$description2;
			}
		}
	}
	
	$this->custom_vars->yandere_themes[] = 'yandere';
	
