<?php
	
	class Yandere_theme_yandere02 extends Yandere_theme
	{
		public function __construct ()
		{
			$this->name = 'Yandere 0.2';
			
			$this->game_name = 'yandere (0.2)';
			$this->game_name_full = 'a yandere (0.2) game';
			$this->game_name_specific = 'the yandere (0.2) game';
			$this->game_name_plural = 'yandere (0.2) games';
			
			$this->generic_victims[] = array(
				'name' => 'Shin-chan',
				'gender' => 'female',
			);
			
			if (property_exists($this, 'role_chooser_version'))
				$this->role_chooser_version = 1;
			
			$this->role_plurals += array
			(
				'baka ranger' => 'baka rangers',
				'civilian' => 'civilians',
				'cloaked ninja' => 'cloaked ninjas',
				'cloaked yandere' => 'cloaked yanderes',
				'esper' => 'espers',
				'guardian' => 'guardians',
				'hikikomori' => 'hikikomoris',
				'idol' => 'idols',
				'magical girl' => 'magical girls',
				'ninja' => 'ninjas',
				'pedobear' => 'pedobears',
				'psychic yandere' => 'psychic yanderes',
				'samurai' => 'samurai',
				'shrine maiden' => 'shrine maidens',
				'spy' => 'spies',
				'stalker' => 'stalkers',
				'tank soldier' => 'tank soldier',
				'trap' => 'traps',
				'tsundere' => 'tsunderes',
				'warrior' => 'warriors',
				'yandere' => 'yanderes',
			);
			
			$this->standard_roles += array
			(
				'innocent' => 'civilian',
				'mafioso' => 'yandere',
				'detective' => 'spy',
			);
			
			$this->role_actions[0] += array // Day
			(
				'esper' => 'spy',
				'cloaked ninja' => 'spy',
				'idol' => 'reveal',
				'magical girl' => 'kill',
				'ninja' => 'spy',
				'pedobear' => 'spy',
				'psychic yandere' => 'spy',
				'samurai' => 'kill',
				'shrine maiden' => 'spy',
				'tank soldier' => 'kill',
			);
			$this->role_actions[1] += array // Night
			(
				'cloaked ninja' => 'kill',
				'cloaked yandere' => 'vote',
				'guardian' => 'guard',
				'hikikomori' => 'hide',
				'magical girl' => 'guard',
				'ninja' => 'kill',
				'psychic yandere' => 'vote',
				'samurai' => 'kill',
				'shrine maiden' => 'guard',
				'spy' => 'spy',
				'stalker' => 'stalk',
				'tank soldier' => 'kill',
				'warrior' => 'kill',
				'yandere' => 'vote',
			);
			
			$this->action_messages[0] += array
			(
				'idol' => 'A limousine pulls up and the famous idol \\1 steps out! \\1 hands everyone autographed copies of the latest album, "I Want You Lovely".',
				'magical girl' => '\\1 transforms into a magical girl and casts Moon Spiral Heart Attack on \\2! \\2\\3 fades away.',
				'samurai' => '\\1 pulls out a samurai sword and drives it through \\2\'s chest! \\2\\3 falls over and dies.',
				'tank soldier' => '\\1 hops into a tank and blasts \\2 to smithereens. \\2\\3 is pretty thoroughly dead.',
			);
			
			$this->enemy_roles = array_merge($this->enemy_roles, array
			(
				'cloaked yandere',
				'psychic yandere',
				'trap',
				'yandere',
			)
			);
			
			$this->always_win_roles = array_merge($this->always_win_roles, array
			(
				'baka ranger',
			)
			);
			
			$this->yandere_role_odds += array
			(
				'yandere' => 94,
				'psychic yandere' => 5,
				'cloaked yandere' => 1,
			);
			
			$this->role_odds += array
			(
				'civilian' => 75,
				'guardian' => 10,
				'warrior' => 10,
				'ninja' => 5,
				'samurai' => 5,
				'stalker' => 5,
				'tsundere' => 5,
				'baka ranger' => 1,
				'cloaked ninja' => 1,
				'esper' => 1,
				'hikikomori' => 1,
				'idol' => 1,
				'magical girl' => 1,
				'pedobear' => 1,
				'shrine maiden' => 1,
				'tank soldier' => 1,
				'trap' => 1,
			);
			
			$this->single_use_roles = array_merge($this->single_use_roles, array
			(
				'cloaked ninja',
				'esper',
				'hikikomori',
				'idol',
				'psychic yandere',
				'magical girl',
				'ninja',
				'samurai',
				'shrine maiden',
				'warrior',
			)
			);
			
			$this->role_appearances += array
			(
				'cloaked ninja' => 'civilian',
				'cloaked yandere' => 'civilian',
				'pedobear' => 'yandere',
				'trap' => 'civilian',
				'tsundere' => 'yandere',
			);
			
			$this->role_descriptions += array
			(
				'baka ranger' => 'Baka rangers have no stakes in the game. You win no matter who wins. Feel free to sabotage either side, and have fun with it. You don\'t have any special abilities.',
				'civilian' => 'Civilians are normal townsfolk with no special abilities.',
				'cloaked ninja' => 'Cloaked ninjas look like normal civilians, and they can either spy on someone once during a day of your choosing OR kill someone once during a night. Type "/msg \\1 \\2spy <user>" during the day or "/msg \\1 \\2kill <user>" during the night.',
				'cloaked yandere' => 'Cloaked yanderes are yanderes that look like civilians to spies. Each night, you vote to kill someone by typing "/msg \\1 \\2vote <user>". The majority vote among the yanderes wins. Earlier votes break ties.',
				'esper' => 'Espers can inspect another player\'s role one time during a day of your choosing. Type "/msg \\1 \\2spy <user>". Be careful of disguised roles like traps and tsunderes which will be misreported.',
				'guardian' => 'Guardians have the ability to protect a player from any danger during the night. Type "/msg \\1 \\2guard <user>". But be careful: if you protect a yandere, the yandere will also attack you!',
				'hikikomori' => 'Hikikomoris can choose to hide during a night of your choosing, keeping safe from any killers that night. Type "/msg \\1 \\2hide" during the night.',
				'idol' => 'Idols are famous! At any time during a day of your choice, you can type "/msg \\1 \\2reveal" to prove to everyone that you\'re an idol.',
				'magical girl' => 'Magical girls can either kill someone once during a day of your choosing OR guard someone once during a night. Type "/msg \\1 \\2kill <user>" during the day or "/msg \\1 \\2guard <user>" during the night.',
				'ninja' => 'Ninjas can either spy on someone once during a day of your choosing OR kill someone once during a night. Type "/msg \\1 \\2spy <user>" during the day or "/msg \\1 \\2kill <user>" during the night.',
				'pedobear' => 'Pedobear scares lolis (he looks like a yandere), but he\'s on the good side, because that\'s where the most lolis are. Every day, he can spy on anyone he wants by typing "/msg \\1 \\2spy <user>".',
				'psychic yandere' => 'Psychic yanderes are yanderes that can inspect another player\'s role one time during a day of your choosing. Type "/msg \\1 \\2spy <user>" during the day or "/msg \\1 \\2vote <user>" during the night.',
				'samurai' => 'Samurai have the ability to single-handedly kill a player of their choosing once during a night or day of your choosing. Type "/msg \\1 \\2kill <user>" if you believe that person is a yandere.',
				'shrine maiden' => 'Shrine maidens can spy once during a day of your choosing OR guard once during a night. Type "/msg \\1 \\2spy <user>" during the day or "/msg \\1 \\2guard <user>" during the night.',
				'spy' => 'Spies can inspect another player\'s role each night. Type "/msg \\1 \\2spy <user>". Be careful of disguised roles like traps and tsunderes which will be misreported.',
				'stalker' => 'Stalkers can learn where another player goes during the night. Each night, type "/msg \\1 \\2stalk <user>". Although you can see a player\'s target, you can\'t see what action the player is performing on that target.',
				'tank soldier' => 'Tank soldiers are killing machines! They can kill anyone they want at any time, once per day and once per night if they want. But remember, you\'re trying to kill the yanderes. Type "/msg \\1 \\2kill <user>".',
				'trap' => 'Traps are normal civilians with no special abilities, except you only win if the yanderes win. You want to sabotage the game in favor of the yanderes. Spies will mistake you for a civilian.',
				'tsundere' => 'Tsunderes are normal civilians with no special abilities, except spies will mistake them for yanderes.',
				'warrior' => 'Warriors have the ability to single-handedly kill a player of their choosing once during a night of your choosing. Type "/msg \\1 \\2kill <user>" if you believe that person is a yandere.',
				'yandere' => 'Yanderes are the villains of the game. Each night, you vote to kill someone by typing "/msg \\1 \\2vote <user>". The majority vote among the yanderes wins. Earlier votes break ties.',
			);
			
			$this->weapons = array_merge($this->weapons, array
			(
				'a crowbar',
				'an axe',
				'a sword',
				'dynamite',
				'a wrench',
				'a fork',
				'a giant plushie',
				'dihydrogen monoxide',
				'a machine gun',
				'a cheese grater',
				'a rolling pin',
				'a frying pan',
				'a staple gun',
				'a sledgehammer',
				'a major papercut',
				'a pineapple',
				'a box of gummy worms',
				'a giant snake',
				'excalibolg',
				'a pretzel',
				'a death note',
				'a mecha',
				'a bowling ball',
				'AIDS',
				'a tentacle monster',
				'a tennis racket',
				'an exploding pen',
				'a cannon',
				'laser beams',
				'a hot glue gun',
				'a frisby',
				'a mutant bee sting',
				'a shark',
				'a yo-yo',
				'ESP',
				'a yak',
				'a box of starving, crazed weasels',
				'a shuriken',
				'a banana',
				'a thermal detonator',
				'a falling house',
				'a Masamune',
				'a mouse trap',
				'a walrus with a top hat',
				'fire',
				'lolicide',
				'cancer',
				'a hybrid vehicle',
				'lolipops',
				'poison cake',
				'a sugar overdose',
				'a Vulcan nerve pinch',
				'a rift in space-time',
				'the power of the void',
				'a rock',
				'a chicken gun',
				'the force',
				'a large hadron collider',
				'a silver bullet',
				'a carrier swarm',
			)
			);
			
			$this->murder_descriptions = array_merge($this->murder_descriptions, array
			(
				'has been brutally murdered by',
				'is dead, killed by',
				'was taken out by',
				'has been killed by',
				'has been murdered by',
				'is lying on the floor, murdered by',
				'has been savagely killed by',
				'was assassinated with',
				'was eliminated by',
				'was knocked off with',
				'has been slain by',
				'was wasted by',
				'was done in by',
			)
			);
		}
		
		public function get_introduction ($phase)
		{
			$GV = $this->generic_victim();
			
			$description1 .= $this->describe_death(null, false).'. ';
			
			switch (mt_rand(0, 2))
			{
			case 0:
				$description2 = 'This looks like the work of '.$this->role_singular($this->get_standard_role('mafioso')).'!';
				break;
			
			case 1:
				$description2 = 'There\'s only one explanation: there is '.$this->role_singular($this->get_standard_role('mafioso')).' among us!';
				break;
			
			case 2:
				$description2 = $GV['E'] . ' seems to have been the victim of '.$this->role_singular($this->get_standard_role('mafioso')).'!';
				break;
			}
			
			switch (mt_rand(0, 12))
			{
			case 0:
				return 'TAIHEN!! The loli village wakes up one morning to a horrible surprise: ' . $GV['name'] . ' '.$description1.$description2;
			case 1:
				return 'All the little lolis go to school one day and notice that ' . $GV['name'] . ' seems to be missing. After school, you go to ' . $GV['eir'] . ' house to check on ' . $GV['em'] . ', and find that ' . $GV['e'] . ' '.$description1.$description2;
			case 2:
				return 'At '.mt_rand(2, 4).':'.str_pad(mt_rand(0, 59), 2, '0', STR_PAD_LEFT).' in the morning, the neighborhood lolis wake up to a scream. It sounds like ' . $GV['name'] . '! You all run to ' . $GV['eir'] . ' room and find that ' . $GV['e'] . ' '.$description1.$description2;
			case 3:
				return 'Today is ' . $GV['name'] . '\'s birthday! And ' . $GV['e'] . '\'s having ichigo cake! All the townslolis eagerly come to ' . $GV['eir'] . ' house, but they\'re met with a surprise: ' . $GV['name'] . ' '.$description1.$description2;
			case 4:
				return $GV['name'] . ' is a quiet, moe loli. But ' . $GV['e'] . '\'s especially quiet today, because ' . $GV['e'] . ' '.$description1.$description2;
			case 5:
				return 'It\'s Christmas morning! ' . $GV['name'] . ' rushes into the living room and sees a great big present with ' . $GV['eir'] . ' name on it. Full of excitement, ' . $GV['e'] . ' rips open the box and finds some sort of weird alarm clock attached to several red sticks. It proceeds to explode. '.$description2;
			case 6:
				return $GV['name'] . ' is riding merrily on the bus on ' . $GV['eir'] . ' way to school. Little does ' . $GV['e'] . ' know it\'s rigged with hundreds of explosives. The bus explodes in a mighty inferno, and ' . $GV['name'] . ' bits go flying everywhere. '.$description2;
			case 7:
				return 'All ' . $GV['eir'] . ' life, ' . $GV['name'] . ' had been plagued by an illness that confined ' . $GV['em'] . ' to ' . $GV['eir'] . ' room. But today, ' . $GV['e'] . ' decided to fulfill ' . $GV['eir'] . ' dream: to risk it and go to school like all the other lolis. But ' . $GV['eir'] . ' lunch was poisoned and ' . $GV['e'] . ' died. '.$description2;
			case 8:
				return 'Everybody loves ' . $GV['name'] . ', except for whoever set ' . $GV['em'] . ' on fire last night. Now ' . $GV['name'] . ' is charcoal. '.$description2;
			case 9:
				return $GV['name'] . ' is baking cookies! Everyone comes over to ' . $GV['eir'] . ' house to taste ' . $GV['eir'] . ' yummy treats. But where is ' . $GV['name'] . '? And what\'s that funny smell coming from the oven? Uh oh! It looks like it\'s ' . $GV['name'] . '-flavored cookies now. '.$description2;
			case 10:
				return $GV['name'] . ' is taking a shower. ' . $GV['E'] . ' begins ' . $GV['eir'] . ' daily ritual of massaging ' . $GV['eir'] . ' chest, hoping to grow breasts soon so ' . $GV['e'] . ' can finally confess to that special someone. But then ' . $GV['e'] . ' screams as the water temperature dramatically rises and quickly burns off all ' . $GV['eir'] . ' flesh, leaving behind a loli skeleton. '.$description2;
			case 11:
				return $GV['name'] . ' has always been small, but ' . $GV['e'] . ' used to be taller than 1cm. At this new size, ' . $GV['e'] . ' was easily swallowed by the pet kitten ' . $GV['e'] . ' got for ' . $GV['eir'] . ' birthday last week. What caused ' . $GV['em'] . ' to shrink anyway? '.$description2;
			case 12:
				return $GV['name'] . ' opens ' . $GV['eir'] . ' shoe locker and finds a love letter! ' . $GV['E'] . '\'d never received a love letter before! It says ' . $GV['eir'] . ' secret admirer will be waiting on the school rooftop. At the end of the day, ' . $GV['e'] . ' eagerly rushes to the roof, where ' . $GV['e'] . ' receives an axe to the face. '.$description2;
			}
		}
	}
	
	$this->custom_vars->yandere_themes[] = 'yandere02';
	
?>
